{ Working with L-1450 }

// definitions for L791 busmaster board


//#define  SETBIT(Var, Bit) (Var |= (0x1L << Bit))
//#define  CLEARBIT(Var, Bit) (Var &= ~(0x1L << Bit))  
//#define  TOGGLEBIT(Var, Bit) (Var ^= (0x1L << Bit))  
//#define  CHECKBIT(Var, Bit) (Var & (0x1L << Bit))

unit cmd791;

interface

const

// raw L791 registers
   R_ADC_BUFFER_L791           = $0000;
   R_DAC_BUFFER_L791           = $0400;
   R_CONTROL_TABLE_L791        = $0600;
   R_CONTROL_TABLE_LENGTH_L791 = $07F4;
   R_CHANNEL_TIME_L791         = $07F8;
   R_INT_FRAME_TIME_L791       = $07FC;
   R_ADC_PAGE_DESC_L791        = $0800;
   R_DAC_PAGE_DESC_L791        = $0A00;
   R_ADC_PCI_COUNT_L791        = $0F80;
   R_DAC_PCI_COUNT_L791        = $0F84;
   R_DAC_TIME_L791             = $0F88;
   R_ADC_BUFFER_PTR_L791       = $0F90;
   R_DAC_BUFFER_PTR_L791       = $0F94;
   R_DIGITAL_IO_L791           = $0F98;
   R_ADC_SAMPLE_QNT_L791       = $0F9C;
   R_ADC_MASTER_QNT_L791       = $0FA0;
   R_FLASH_ADDRESS_L791        = $0FA4;
   R_FLASH_DATA_L791           = $0F8C;
   R_INTERRUPT_ENABLE_L791     = $0FF0;
   R_STATUS_L791               = $0FF8;
   R_CONTROL_L791              = $0FFC;

// dword array access index
   I_ADC_BUFFER_L791           = ($0000 shr 2);
   I_DAC_BUFFER_L791           = ($0400 shr 2);
   I_CONTROL_TABLE_L791        = ($0600 shr 2);
   I_CONTROL_TABLE_LENGTH_L791 = ($07F4 shr 2);
   I_CHANNEL_TIME_L791         = ($07F8 shr 2);
   I_INT_FRAME_TIME_L791       = ($07FC shr 2);
   I_ADC_PAGE_DESC_L791        = ($0800 shr 2);
   I_DAC_PAGE_DESC_L791        = ($0A00 shr 2);
   I_ADC_PCI_COUNT_L791        = ($0F80 shr 2);
   I_DAC_PCI_COUNT_L791        = ($0F84 shr 2);
   I_DAC_TIME_L791             = ($0F88 shr 2);
   I_ADC_BUFFER_PTR_L791       = ($0F90 shr 2);
   I_DAC_BUFFEI_PTR_L791       = ($0F94 shr 2);
   I_DIGITAL_IO_L791           = ($0F98 shr 2);
   I_ADC_SAMPLE_QNT_L791       = ($0F9C shr 2);
   I_ADC_MASTER_QNT_L791       = ($0FA0 shr 2);
   I_FLASH_ADDRESS_L791        = ($0FA4 shr 2);
   I_FLASH_DATA_L791           = ($0F8C shr 2);
   I_INTERRUPT_ENABLE_L791     = ($0FF0 shr 2);
   I_STATUS_L791               = ($0FF8 shr 2);
   I_CONTROL_L791              = ($0FFC shr 2);

// bits defines
// CONTROL_REGISTER
   BIT_ADC_EN = 0;
   BIT_ADC_MASTER_EN = 1;
   BIT_CLR_ADC_CNT = 2;
   BIT_AUTO_STOP_ADC_MST = 3;
   BIT_AUTO_STOP_ADC = 4;
// 5-7 reserved
   BIT_SYNC_MODE_0 = 8; //
   BIT_SYNC_MODE_1 = 9; //00 - no sync 10 - digital start 11 - digital kadr sync
   BIT_SYNC_SOURCE = 10;
// 11 reserved
   BIT_ADC_BUF_DEPTH_0 = 12;
   BIT_ADC_BUF_DEPTH_1 = 13;
   BIT_ADC_BUF_DEPTH_2 = 14;
// 15 reserved
   BIT_DAC_EN = 16;
   BIT_DAC_MASTER_EN = 17;
   BIT_CLR_DAC_CNT = 18;
// 19-23 reserved
   BIT_EEPROM_CMD_0 = 24;
   BIT_EEPROM_CMD_1 = 25;
   BIT_EEPROM_START = 26;
   BIT_EEPROM_WR_EN = 27;
   BIT_OUTPUT_EN = 28;
//29-31 reserved


// STATUS_REGISTER
   SBIT_ADC_MST_EVENT = 0;
   SBIT_ADC_OVF_EVENT = 1;
// 2 reserved
   SBIT_ADC_BUF_EVENT = 3;
// 4-15 reserved
   SBIT_DAC_USR_EVENT = 16;
// 17 reserved
   SBIT_DAC_UNF_EVENT = 18;
// 19-23 reserved
   SBIT_PWR_OVR_EVENT = 24;
   SBIT_EEPROM_BUSY = 25;
// 26 -30 reserved
   SBIT_INT = 31;

// IRQ_ENABLE_REGISTER
//IBIT
// not yet writed

implementation

end.


