unit E2010Cmd;

interface

{ Internal variables }
const


   V_RESET_FPGA_E2010           = 0;
   V_PUT_ARRAY_E2010            = 1;
   V_GET_ARRAY_E2010            = 2;
   V_INIT_FPGA_E2010            = 3;
   V_START_ADC_E2010            = 4;
   V_STOP_ADC_E2010             = 5;
   V_GET_MODULE_NAME_E2010      = 11;
   V_CALL_APPLICATION_E2010     = 15;
// 13 - special put_array


// synchro config
   INT_START_TRANS       = $01;
   INT_START             = $81;
   EXT_START_UP          = $84;
   EXT_START_DOWN        = $94;
   EXT_STRTA_DOWN_REVB   = $8C; //(0x84+0x08)
// clock src
   INT_CLK_TRANS         = $00;
   INT_CLK               = $40;
   EXT_CLK_UP            = $42;
   EXT_CLK_DOWN          = $62;

//bit macros for channel input range and mode config, use |/+ operator to configure
   V30_0             = $0000;
   V10_0             = $0008;
   V03_0             = $0010;
   GND_0             = $0000;
   SIG_0             = $0400;

   V30_1             = $0000;
   V10_1             = $0002;
   V03_1             = $0004;
   GND_1             = $0000;
   SIG_1             = $0200;

   V30_2             = $0000;
   V10_2             = $8000;
   V03_2             = $0100;
   GND_2             = $0000;
   SIG_2             = $1000;

   V30_3             = $0000;
   V10_3             = $2000;
   V03_3             = $4000;
   GND_3             = $0000;
   SIG_3             = $0800;

// advanced analog sync
   A_SYNC_OFF        = $0000;
   A_SYNC_UP_EDGE    = $0080;
   A_SYNC_DOWN_EDGE  = $0084;
   A_SYNC_HL_LEVEL   = $0088;
   A_SYNC_LH_LEVEL   = $008C;

// channel num macros
   CH_0              = $00;
   CH_1              = $01;
   CH_2              = $02;
   CH_3              = $03;


//        
   SEL_TEST_MODE     = $81000000;
   SEL_AVR_DM        = $82000000;
   SEL_AVR_PM        = $83000000;
   SEL_DIO_PARAM     = $84000000;
   SEL_DIO_DATA      = $85000000;
   SEL_ADC_PARAM     = $86000000;
//#define SEL_ADC_DATA          (0x87000000L)

   SEL_BULK_REQ_SIZE    = $88000000;
   SEL_DAC_DATA         = $89000000;
   SEL_ADC_CALIBR_KOEFS = $8A000000;
   SEL_FPGA_DATA        = $8B000000;
   SEL_DEBUG_INFO       = $8F000000;


//     
   FIRMWARE_START_ADDRESS           = (SEL_AVR_PM or $0000);
   USER_FLASH_ADDRESS               = (SEL_AVR_PM or $2D00);
   FIRMWARE_DESCRIPTOR_ADDRESS      = (SEL_AVR_PM or $2F00);
   MODULE_DESCRIPTOR_ADDRESS        = (SEL_AVR_PM or $3000);
   BOOT_LOADER_START_ADDRESS        = (SEL_AVR_PM or $3C00);
   BOOT_LOADER_DESCRIPTOR_ADDRESS   = (SEL_AVR_PM or $3FB0);

//       
   DATA_STATE_ADDRESS               = (SEL_AVR_DM or ($0150 + $00));
   EXTRA_SYNCHRO_PARS_ADDRESS       = (SEL_AVR_DM or ($0150 + 13));
   ADC_CORRECTION_ADDRESS           = (SEL_AVR_DM or ($0150 + 13 + 13));
   LUSBAPI_OR_LCOMP_ADDRESS         = (SEL_AVR_DM or ($0150 + 13 + 13 + 1));


   EP1K10_SIZE = (22*1024+100);

implementation


end.
