{ Working with E440 boards }

unit E440Cmd;

interface
uses Windows;

type
USHORT = WORD;

{ Internal variables }
const


   cmTEST_E440                = 0;
   cmENABLE_FLASH_WRITE_E440  = 1;
   cmREAD_FLASH_WORD_E440     = 2;
   cmWRITE_FLASH_WORD_E440    = 3;
   cmSTART_ADC_E440           = 4;
   cmSTOP_ADC_E440            = 5;
   cmADC_KADR_E440            = 6;
   cmADC_SAMPLE_E440          = 7;
   cmSTART_DAC_E440           = 8;
   cmSTOP_DAC_E440            = 9;
   cmDAC_SAMPLE_E440          = 10;
   cmENABLE_TTL_OUT_E440      = 11;
   cmTTL_IN_E440              = 12;
   cmTTL_OUT_E440             = 13;
   cmLAST_COMMAND_E440        = 14;



   V_RESET_DSP_E440       = 0;
   V_PUT_ARRAY_E440       = 1;
   V_GET_ARRAY_E440       = 2;
   V_START_ADC_E440       = 3;
   V_START_DAC_E440       = 4;
   V_COMMAND_IRQ_E440     = 5;
   V_GO_SLEEP_E440        = 6;
   V_WAKEUP_E440          = 7;
   V_GET_MODULE_NAME_E440 = 11;


// all data in PM so we convert it to USHORT...
//#define LBIOS_OUTVAR(v) ((ULONG)v<<8)
//#define LBIOS_INVAR(v) ((USHORT)(v>>8))

   DM_E440 = $4000;
   PM_E440 = $0000;


   DataBaseAddress_E440  = $30;


   L_PROGRAM_BASE_ADDRESS_E440          =  (DataBaseAddress_E440 + $0);
   L_READY_E440                         =  (DataBaseAddress_E440 + $1);
   L_TMODE1_E440                        =  (DataBaseAddress_E440 + $2);
   L_TMODE2_E440                        =  (DataBaseAddress_E440 + $3);
   L_TEST_LOAD_E440                     =  (DataBaseAddress_E440 + $4);
   L_COMMAND_E440                       =  (DataBaseAddress_E440 + $5);

   L_DAC_SCLK_DIV_E440                  =  (DataBaseAddress_E440 + $7);
   L_DAC_RATE_E440                      =  (DataBaseAddress_E440 + $8);
   L_ADC_RATE_E440                      =  (DataBaseAddress_E440 + $9);
   L_ADC_ENABLED_E440                   =  (DataBaseAddress_E440 + $A);
   L_ADC_FIFO_BASE_ADDRESS_E440         =  (DataBaseAddress_E440 + $B);
   L_CUR_ADC_FIFO_LENGTH_E440           =  (DataBaseAddress_E440 + $C);
   L_ADC_FIFO_LENGTH_E440               =  (DataBaseAddress_E440 + $E);
   L_CORRECTION_ENABLED_E440            =  (DataBaseAddress_E440 + $F);
   L_LBIOS_VERSION_E440                 =  (DataBaseAddress_E440 + $10);
   L_ADC_SAMPLE_E440                    =  (DataBaseAddress_E440 + $11);
   L_ADC_CHANNEL_E440                   =  (DataBaseAddress_E440 + $12);
   L_INPUT_MODE_E440                    =  (DataBaseAddress_E440 + $13);
   L_SYNCHRO_AD_CHANNEL_E440            =  (DataBaseAddress_E440 + $16);
   L_SYNCHRO_AD_POROG_E440              =  (DataBaseAddress_E440 + $17);
   L_SYNCHRO_AD_MODE_E440               =  (DataBaseAddress_E440 + $18);
   L_SYNCHRO_AD_TYPE_E440               =  (DataBaseAddress_E440 + $19);

   L_CONTROL_TABLE_LENGHT_E440          =  (DataBaseAddress_E440 + $1B);
   L_FIRST_SAMPLE_DELAY_E440            =  (DataBaseAddress_E440 + $1C);
   L_INTER_KADR_DELAY_E440              =  (DataBaseAddress_E440 + $1D);

   L_DAC_SAMPLE_E440                    =  (DataBaseAddress_E440 + $20);
   L_DAC_ENABLED_E440                   =  (DataBaseAddress_E440 + $21);
   L_DAC_FIFO_BASE_ADDRESS_E440         =  (DataBaseAddress_E440 + $22);
   L_CUR_DAC_FIFO_LENGTH_E440           =  (DataBaseAddress_E440 + $24);
   L_DAC_FIFO_LENGTH_E440               =  (DataBaseAddress_E440 + $25);

   L_FLASH_ENABLED_E440                 =  (DataBaseAddress_E440 + $26);
   L_FLASH_ADDRESS_E440                 =  (DataBaseAddress_E440 + $27);
   L_FLASH_DATA_E440                    =  (DataBaseAddress_E440 + $28);

   L_ENABLE_TTL_OUT_E440                =  (DataBaseAddress_E440 + $29);
   L_TTL_OUT_E440                       =  (DataBaseAddress_E440 + $2A);
   L_TTL_IN_E440                        =  (DataBaseAddress_E440 + $2B);

   L_SCALE_E440                         = (DataBaseAddress_E440 + $30);
   L_ZERO_E440                          = (DataBaseAddress_E440 + $34);

   L_CONTROL_TABLE_E440                 = $80;

   function LBIOS_OUTVAR(v:USHORT):ULONG;// ((ULONG)v<<8)
   function LBIOS_INVAR(v:ULONG):USHORT;// ((USHORT)(v>>8))

implementation

   function LBIOS_OUTVAR(v:USHORT):ULONG;
   var t:ULONG;
   begin
      t:=v;
      Result:= t shl 8;
   end;

   function LBIOS_INVAR(v:ULONG):USHORT;
   begin
      Result:= v shr 8;
   end;


end.
