#ifndef __STR_ZOOM___
#define __STR_ZOOM__
#include <stdio.h>

#pragma pack(1)
struct ZoomParam
{
   int GridX,GridY;
   COLORREF BgColor;
   COLORREF ZoomColor;
   COLORREF CursorColor;
   COLORREF ZoomGridColor;
   void Set(int nx, int ny, COLORREF bc, COLORREF zc, COLORREF cc, COLORREF zg)
   {
      GridX=nx; GridY=ny;
      BgColor=bc; ZoomColor=zc; CursorColor=cc; ZoomGridColor=zg;
   }
};


struct ZoomScale
{
   float Xmin;
   float Xmax;
   float Ymin;
   float Ymax;
   float Rmax;
   float Rmin;
   int Width;     // How much digits in scale subscription
   char Format[10];

   void Set( float xmi=-1.0f, float xma=1.0f, float ymi=-1.0f, float yma=1.0f,
             float rmi=-1.0f, float rma=1.0f, int w=10, char *f="%-10.1f")
   {
      Xmin=xmi; Xmax=xma; Ymin=ymi; Ymax=yma;
      Rmin=rmi; Rmax=rma; Width=w;
      memcpy(Format,f,sizeof(Format));
   }

};

struct OSCInfo
{
   int CIndex;
   int IndexMin, IndexMax;
   ZoomScale Scale;
};
#pragma pack()

#endif