; lcomp.nsi
; nsis v 2.46 MUI v2

SetCompressor /SOLID lzma

; The file to write
OutFile "lcomp.exe"

Caption "LCard SDK  Windows XP/Vista/W7/W8/W10"

Name "LCard SDK"

BrandingText "LCard SDK L-Comp v7.2"

; The default installation directory
InstallDir $PROGRAMFILES\LCard
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\LCARD_LComp" "Install_Dir"

ManifestSupportedOS all

!include "MUI2.nsh"
!include "x64.nsh"
!include "WinVer.nsh"


!define SourceDir "F:\SYS.MY\git\lcomp\INSTALL"
!define UninstallFile "unlcomp.exe"

!define MUI_LANGDLL_REGISTRY_ROOT "HKLM" 
!define MUI_LANGDLL_REGISTRY_KEY "Software\LCARD_LComp" 
!define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"

!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "lcomp_s.bmp" ; optional
!define MUI_ABORTWARNING

!define MUI_WELCOMEFINISHPAGE_BITMAP "lcomp_w.bmp"


!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "license.txt"
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; First is default
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

LangString Message ${LANG_ENGLISH} "Reboot computer?"
LangString Message ${LANG_RUSSIAN} " ?"

!insertmacro MUI_RESERVEFILE_LANGDLL

Function .onInit

   ${If} ${RunningX64}
     MessageBox MB_OK "Running on x64"
   ${Else}
     MessageBox MB_OK "Running on x86"
   ${EndIf}

   !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd


; The stuff to install
Section "LCard SDK (required)"
   SectionIn RO

   ; Set output path to the installation directory.
   SetOutPath $INSTDIR
   File /r "${SourceDir}\LIBRARY"

   ${If} ${RunningX64}
      ${DisableX64FSRedirection}
      SetOutPath $WINDIR\SYSTEM32
      File "${SourceDir}\LIBRARY\BIN\lcomp64.dll"
      ${EnableX64FSRedirection}
      SetOutPath $WINDIR\SYSTEM32
      File "${SourceDir}\LIBRARY\BIN\lcomp.dll"
      File "${SourceDir}\LIBRARY\BIN\wlcomp.dll"
   ${Else}
      SetOutPath $WINDIR\SYSTEM32
      File "${SourceDir}\LIBRARY\BIN\*.*"
   ${EndIf}      

   SetOutPath $INSTDIR
   File "${SourceDir}\REG\*.*"

   ${If} ${IsWin10}
      CopyFiles "$INSTDIR\Library\DRV\PCI\lcardpci.w10" "$INSTDIR\Library\DRV\PCI\lcardpci.cat"
      CopyFiles "$INSTDIR\Library\DRV\PCIMASTER\ldevpcim.w10" "$INSTDIR\Library\DRV\PCIMASTER\ldevpcim.cat"
      CopyFiles "$INSTDIR\Library\DRV\USB\ldevusbu.w10" "$INSTDIR\Library\DRV\USB\ldevusbu.cat"
      ${If} ${RunningX64}
         ExecWait '"$INSTDIR\dpinst64.exe" /SA /F /PATH "$INSTDIR\Library\DRV"'
      ${Else}
;         ExecWait '"$INSTDIR\dpinst.exe" /c /q /sa /sw /f /path "$INSTDIR\Library\DRV"'
         ExecWait '"$INSTDIR\dpinst.exe" /SA /F /PATH "$INSTDIR\Library\DRV"'
;         ExecWait '"$INSTDIR\Library\DRV\dpinst.exe" /sa /lm /f'
      ${EndIf}
   ${Else}
      CopyFiles "$INSTDIR\Library\DRV\PCI\lcardpci.w7" "$INSTDIR\Library\DRV\PCI\lcardpci.cat"
      CopyFiles "$INSTDIR\Library\DRV\PCIMASTER\ldevpcim.w7" "$INSTDIR\Library\DRV\PCIMASTER\ldevpcim.cat"
      CopyFiles "$INSTDIR\Library\DRV\USB\ldevusbu.w7" "$INSTDIR\Library\DRV\USB\ldevusbu.cat"

      ${If} ${RunningX64}
         ExecWait '"$INSTDIR\dpinst64.exe" /SA /F /PATH "$INSTDIR\Library\DRV"'
      ${Else}
;         ExecWait '"$INSTDIR\dpinst.exe" /c /q /sa /sw /f /path "$INSTDIR\Library\DRV"'
         ExecWait '"$INSTDIR\dpinst.exe" /SA /F /PATH "$INSTDIR\Library\DRV"'
;         ExecWait '"$INSTDIR\Library\DRV\dpinst.exe" /sa /lm /f'
      ${EndIf}
   ${EndIf}


   ${If} ${RunningX64}
      ExecWait '$INSTDIR\devcon64.exe remove "PCI\VEN_10B5&DEV_9050&SUBSYS_4C373830&REV_01" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "PCI\VEN_10B5&DEV_9050&SUBSYS_4C373833&REV_01" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "PCI\VEN_10B5&DEV_9050&SUBSYS_4C373631&REV_01" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "PCI\VEN_1172&DEV_0791&SUBSYS_4C373931&REV_00" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "PCI\VEN_10B5&DEV_9030&SUBSYS_4C373830&REV_0A" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "PCI\VEN_10B5&DEV_9030&SUBSYS_4C373833&REV_0A" > nul'

      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_0440" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_0140" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_2010" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_2121" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_1010" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_3131" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_3030" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_0154" > nul'


      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_E310" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_EFFF" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_2A52&PID_EFFF" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_2A52&PID_CA01" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_0124" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_F101" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_0471&PID_F003" > nul'
      ExecWait '$INSTDIR\devcon64.exe remove "USB\VID_2A52&PID_2122" > nul'


   ${Else}
      ExecWait '$INSTDIR\devcon.exe remove "PCI\VEN_10B5&DEV_9050&SUBSYS_4C373830&REV_01" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "PCI\VEN_10B5&DEV_9050&SUBSYS_4C373833&REV_01" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "PCI\VEN_10B5&DEV_9050&SUBSYS_4C373631&REV_01" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "PCI\VEN_1172&DEV_0791&SUBSYS_4C373931&REV_00" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "PCI\VEN_10B5&DEV_9030&SUBSYS_4C373830&REV_0A" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "PCI\VEN_10B5&DEV_9030&SUBSYS_4C373833&REV_0A" > nul'

      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_0440" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_0140" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_2010" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_2121" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_1010" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_3131" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_3030" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_0154" > nul'

      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_E310" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_EFFF" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_2A52&PID_EFFF" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_2A52&PID_CA01" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_0124" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_F101" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_0471&PID_F003" > nul'
      ExecWait '$INSTDIR\devcon.exe remove "USB\VID_2A52&PID_2122" > nul'


   ${EndIf}

   ; Write the installation path into the registry
   WriteRegStr HKLM SOFTWARE\LCARD_LComp "Install_Dir" $INSTDIR
   ; Write the uninstall keys for Windows
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\LComp" "DisplayName" "LCard SDK (remove only)"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\LComp" "UninstallString" '"$INSTDIR\${UninstallFile}"'
   WriteUninstaller $INSTDIR\${UninstallFile}

SectionEnd

; optional section
Section "L-Graph I"
   SetOutPath $INSTDIR
   File /r "${SourceDir}\LGRAPH"
SectionEnd

Section "Start Menu Shortcuts"
   CreateDirectory "$SMPROGRAMS\LCard SDK"
   CreateShortCut  "$SMPROGRAMS\LCard SDK\Uninstall.lnk" "$INSTDIR\${UninstallFile}" "" "$INSTDIR\${UninstallFile}" 0
   CreateShortCut  "$SMPROGRAMS\LCard SDK\Help.lnk" "$INSTDIR\Library\HELP\lcomp.chm" "" "$INSTDIR\Library\HELP\lcomp.chm" 0
   CreateShortCut  "$SMPROGRAMS\LCard SDK\Manual.lnk" "$INSTDIR\Library\HELP\manual.pdf" "" "$INSTDIR\Library\HELP\manual.pdf" 0
   CreateShortCut  "$SMPROGRAMS\LCard SDK\Readme.lnk" "$INSTDIR\Library\README\readme.txt" "" "$INSTDIR\Library\README\readme.txt" 0
   CreateShortCut  "$SMPROGRAMS\LCard SDK\LabView readme.lnk" "$INSTDIR\Library\WLCOMP_LV\instruct.html" "" "$INSTDIR\Library\WLCOMP_LV\instruct.html" 0
   SetOutPath $INSTDIR\LGRAPH
   CreateShortCut  "$SMPROGRAMS\LCard SDK\L-Graph I.lnk" "$INSTDIR\LGRAPH\lgraph.exe" "" "$INSTDIR\LGRAPH\lgraph.exe" 0
SectionEnd

; readme section with reboot option
Section
   ExecShell open "$INSTDIR\Library\README\readme.txt"
   MessageBox MB_YESNO|MB_ICONQUESTION $(Message) IDNO +2
   Reboot
SectionEnd


; special uninstall section.
Section "Uninstall"
   ; remove registry keys
   DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\LComp"
   DeleteRegKey HKLM "Software\LCARD_LComp"

   ; remove drivers

   ${If} ${RunningX64}
      ExecWait '"$INSTDIR\dpinst64.exe" /S /D /U "$INSTDIR\Library\DRV\USB\ldevusbu.inf"'
      ExecWait '"$INSTDIR\dpinst64.exe" /S /D /U "$INSTDIR\Library\DRV\PCIMASTER\ldevpcim.inf"'
      ExecWait '"$INSTDIR\dpinst64.exe" /S /D /U "$INSTDIR\Library\DRV\PCI\lcardpci.inf"'
   ${Else}
      ExecWait '"$INSTDIR\dpinst.exe" /S /D /U "$INSTDIR\Library\DRV\USB\ldevusbu.inf"'
      ExecWait '"$INSTDIR\dpinst.exe" /S /D /U "$INSTDIR\Library\DRV\PCIMASTER\ldevpcim.inf"'
      ExecWait '"$INSTDIR\dpinst.exe" /S /D /U "$INSTDIR\Library\DRV\PCI\lcardpci.inf"'
   ${EndIf}

   ; remove files
   Delete $INSTDIR\Library\*.*
   Delete $INSTDIR\LGRAPH\*.*
   Delete $INSTDIR\devcon.exe
   Delete $INSTDIR\devcon64.exe
   Delete $INSTDIR\dpinst.exe
   Delete $INSTDIR\dpinst64.exe
   Delete $INSTDIR\dpinst.xml

   ; MUST REMOVE UNINSTALLER, too
   Delete $INSTDIR\${UninstallFile}
   ; remove shortcuts, if any.
   Delete "$SMPROGRAMS\LCard SDK\*.*"
   ; remove directories used.
   RMDir "$SMPROGRAMS\LCard SDK"
   RMDir /r "$INSTDIR\Library"
   RMDir /r "$INSTDIR\LGRAPH"
   RMDir $INSTDIR
SectionEnd

Function un.onInit
  !insertmacro MUI_UNGETLANGUAGE
FunctionEnd

