#define INITGUID

#include <windows.h>
#include <objbase.h>

#include "..\include\ioctl.h"
#include "..\include\ifc_ldev.h"
#include "..\include\wlcomp.h"


//            L_ULONG 
//       ...       ...

//     

//    ULONG,    PL_ULONG  ....  

typedef IDaqLDevice* (*CREATEFUNCPTR)(ULONG slot);

//   
DllExport(L_ULONG) LoadAPIDLL(char *dllname)
{
   return (L_ULONG)::LoadLibrary(dllname);
}

//  
DllExport(ULONG) FreeAPIDLL(PL_ULONG hDll)
{
   return ::FreeLibrary((HINSTANCE)*hDll);
}

//     
DllExport(LPVOID) CallCreateInstance(PL_ULONG hDll, ULONG slot, PULONG Err) // return handle for new iface
{
   *Err = L_SUCCESS;
   if(hDll== NULL) { *Err = L_ERROR; return NULL; }
   CREATEFUNCPTR CreateInstance = (CREATEFUNCPTR)::GetProcAddress((HINSTANCE)*hDll, "CreateInstance");
   if(CreateInstance == NULL) { *Err = L_ERROR; return NULL; }
   LUnknown* pIUnknown = CreateInstance(slot);// pointer to interface
   if(pIUnknown == NULL) { *Err = L_ERROR; /*("CallCreateInstance failed");*/ return NULL; }
   IDaqLDevice* pI;
   HRESULT hr = pIUnknown->QueryInterface(IID_ILDEV,(void**)&pI);
   pIUnknown->Release();
   if(!SUCCEEDED(hr)) { *Err = L_ERROR; /*("Get IDaqLDevice failed");*/ return NULL; }
   return pI;
}


DllExport(ULONG)  inbyte ( PL_ULONG hIfc, ULONG offset, PUCHAR data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->inbyte(offset,data, len, key);
}

DllExport(ULONG)  inword ( PL_ULONG hIfc, ULONG offset, PUSHORT data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->inword(offset,data, len, key);
}

DllExport(ULONG)  indword( PL_ULONG hIfc, ULONG offset, PULONG data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->indword(offset,data, len, key);
}

DllExport(ULONG)  outbyte ( PL_ULONG hIfc, ULONG offset, PUCHAR data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->outbyte(offset,data, len, key);
}

DllExport(ULONG)  outword ( PL_ULONG hIfc, ULONG offset, PUSHORT data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->outword(offset,data, len, key);
}

DllExport(ULONG)  outdword( PL_ULONG hIfc, ULONG offset, PULONG data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->outdword(offset,data, len, key);
}

   // Working with MEM ports
DllExport(ULONG)  inmbyte ( PL_ULONG hIfc, ULONG offset, PUCHAR data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->inmbyte(offset,data, len, key);
}

DllExport(ULONG)  inmword ( PL_ULONG hIfc, ULONG offset, PUSHORT data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->inmword(offset,data, len, key);
}

DllExport(ULONG)  inmdword( PL_ULONG hIfc, ULONG offset, PULONG data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->inmdword(offset,data, len, key);
}

DllExport(ULONG)  outmbyte ( PL_ULONG hIfc, ULONG offset, PUCHAR data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->outmbyte(offset,data, len, key);
}

DllExport(ULONG)  outmword ( PL_ULONG hIfc, ULONG offset, PUSHORT data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->outmword(offset,data, len, key);
}

DllExport(ULONG)  outmdword( PL_ULONG hIfc, ULONG offset, PULONG data, ULONG len, ULONG key)
{
   return ((IDaqLDevice*)*hIfc)->outmdword(offset,data, len, key);
}

///////////////////////////
DllExport(ULONG)  GetWord_DM(PL_ULONG hIfc, USHORT Addr, PUSHORT Data)
{
   return ((IDaqLDevice*)*hIfc)->GetWord_DM(Addr,Data);
}

DllExport(ULONG)  PutWord_DM(PL_ULONG hIfc, USHORT Addr, USHORT Data)
{
   return ((IDaqLDevice*)*hIfc)->PutWord_DM(Addr,Data);
}

DllExport(ULONG)  PutWord_PM(PL_ULONG hIfc, USHORT Addr, ULONG Data)
{
   return ((IDaqLDevice*)*hIfc)->PutWord_PM(Addr,Data);
}

DllExport(ULONG)  GetWord_PM(PL_ULONG hIfc, USHORT Addr, PULONG Data)
{
   return ((IDaqLDevice*)*hIfc)->GetWord_PM(Addr,Data);
}

DllExport(ULONG)  GetArray_DM(PL_ULONG hIfc, USHORT Addr, ULONG Count, PUSHORT Data)
{
   return ((IDaqLDevice*)*hIfc)->GetArray_DM(Addr,Count,Data);
}

DllExport(ULONG)  PutArray_DM(PL_ULONG hIfc, USHORT Addr, ULONG Count, PUSHORT Data)
{
   return ((IDaqLDevice*)*hIfc)->PutArray_DM(Addr,Count,Data);
}

DllExport(ULONG)  PutArray_PM(PL_ULONG hIfc, USHORT Addr, ULONG Count, PULONG Data)
{
   return ((IDaqLDevice*)*hIfc)->PutArray_PM(Addr,Count,Data);
}

DllExport(ULONG)  GetArray_PM(PL_ULONG hIfc, USHORT Addr, ULONG Count, PULONG Data)
{
   return ((IDaqLDevice*)*hIfc)->GetArray_PM(Addr,Count,Data);
}

DllExport(ULONG)  SendCommand(PL_ULONG hIfc, USHORT Cmd)
{
   return ((IDaqLDevice*)*hIfc)->SendCommand(Cmd);
}

/////////////////////
DllExport(ULONG)  PlataTest(PL_ULONG hIfc)
{  
   return ((IDaqLDevice*)*hIfc)->PlataTest();
}

DllExport(ULONG)  GetSlotParam(PL_ULONG hIfc, PSLOT_PAR slPar)
{
   return ((IDaqLDevice*)*hIfc)->GetSlotParam(slPar);
}

//  return   Handle  ,        ,   
DllExport(L_ULONG) OpenLDevice(PL_ULONG hIfc)
{
   return (L_ULONG)(((IDaqLDevice*)*hIfc)->OpenLDevice());
}

DllExport(ULONG)  CloseLDevice(PL_ULONG hIfc)
{
   ULONG Err=((IDaqLDevice*)*hIfc)->CloseLDevice();
   ((IDaqLDevice*)*hIfc)->Release();
   return Err;
}

DllExport(ULONG)  RequestBufferStream(PL_ULONG hIfc, ULONG *Size, ULONG StreamId) //in words
{
   return ((IDaqLDevice*)*hIfc)->RequestBufferStream(Size,StreamId);
}

DllExport(ULONG)  SetParametersStream(PL_ULONG hIfc, LPVOID sp, ULONG sp_type, ULONG *UsedSize, void** Data, void** Sync, ULONG StreamId)
{
   ULONG Err;   
//DAC_PAR_0 d0_sp;  //0
//DAC_PAR_1 d1_sp;  //1
//ADC_PAR_0 a0_sp;  //2
//ADC_PAR_1 a1_sp;  //3

   PWDAQ_PAR wd_sp = (PWDAQ_PAR)sp;
      //   
   switch (sp_type) {
      case CASE_DAC_PAR_0:
         {
            DAC_PAR_0 d0_sp;
            Err=((IDaqLDevice*)*hIfc)->SetParametersStream(&d0_sp, UsedSize, Data, Sync, StreamId);
            wd_sp->t1.Pages = d0_sp.Pages;
            wd_sp->t1.FIFO = d0_sp.FIFO;
            wd_sp->t1.IrqStep = d0_sp.IrqStep;
         } break;
      case CASE_DAC_PAR_1:
         {
            DAC_PAR_1 d1_sp;
            Err=((IDaqLDevice*)*hIfc)->SetParametersStream(&d1_sp, UsedSize, Data, Sync, StreamId);
            wd_sp->t2.Pages = d1_sp.Pages;
            wd_sp->t2.FIFO = d1_sp.FIFO;
            wd_sp->t2.IrqStep = d1_sp.IrqStep;
         } break;
      case CASE_ADC_PAR_0:
         {
            ADC_PAR_0 a0_sp;
            Err=((IDaqLDevice*)*hIfc)->SetParametersStream(&a0_sp, UsedSize, Data, Sync, StreamId);
            wd_sp->t3.Pages = a0_sp.Pages;
            wd_sp->t3.FIFO = a0_sp.FIFO;
            wd_sp->t3.IrqStep = a0_sp.IrqStep;
//            wd_sp->t3.dRate = a0_sp.dRate;
//            wd_sp->t3.dKadr = a0_sp.dKadr;
         } break;
      case CASE_ADC_PAR_1:
         {
            ADC_PAR_1 a1_sp;
            Err=((IDaqLDevice*)*hIfc)->SetParametersStream(&a1_sp, UsedSize, Data, Sync, StreamId);
            wd_sp->t4.Pages = a1_sp.Pages;
            wd_sp->t4.FIFO = a1_sp.FIFO;
            wd_sp->t4.IrqStep = a1_sp.IrqStep;
//            wd_sp->t4.dRate = a1_sp.dRate;
//            wd_sp->t4.dKadr = a1_sp.dKadr;
         } break;
   }
   return Err;
}


DllExport(ULONG)  FillDAQparameters(PL_ULONG hIfc, LPVOID sp, ULONG sp_type)
{
ULONG Err;
//DAC_PAR_0 d0_sp;  //0
//DAC_PAR_1 d1_sp;  //1
//ADC_PAR_0 a0_sp;  //2
//ADC_PAR_1 a1_sp;  //3
PWDAQ_PAR wd_sp = (PWDAQ_PAR)sp;
      //   
   switch (sp_type) {
      case CASE_DAC_PAR_0:
         {
            DAC_PAR_0 d0_sp;
            d0_sp.s_Type = wd_sp->t1.s_Type;
            d0_sp.FIFO = wd_sp->t1.FIFO;
            d0_sp.IrqStep = wd_sp->t1.IrqStep;
            d0_sp.Pages = wd_sp->t1.Pages;
            d0_sp.AutoInit = wd_sp->t1.AutoInit;
            d0_sp.dRate = wd_sp->t1.dRate;
            d0_sp.Rate = wd_sp->t1.Rate;
            d0_sp.DacNumber = wd_sp->t1.DacNumber;
            d0_sp.DacEna = wd_sp->t1.DacEna;
            d0_sp.IrqEna = wd_sp->t1.IrqEna;

            Err=((IDaqLDevice*)*hIfc)->FillDAQparameters(&d0_sp);
            wd_sp->t1.dRate = d0_sp.dRate;

         } break;
      case CASE_DAC_PAR_1:
         {
            DAC_PAR_1 d1_sp;
            d1_sp.s_Type = wd_sp->t2.s_Type;
            d1_sp.FIFO = wd_sp->t2.FIFO;
            d1_sp.IrqStep = wd_sp->t2.IrqStep;
            d1_sp.Pages = wd_sp->t2.Pages;
            d1_sp.AutoInit = wd_sp->t2.AutoInit;
            d1_sp.dRate = wd_sp->t2.dRate;
            d1_sp.Rate = wd_sp->t2.Rate;
            d1_sp.DacEna = wd_sp->t2.DacEna;
            d1_sp.IrqEna = wd_sp->t2.IrqEna;

            Err=((IDaqLDevice*)*hIfc)->FillDAQparameters(&d1_sp);
            wd_sp->t2.dRate = d1_sp.dRate;

         } break;
      case CASE_ADC_PAR_0:
         {
            ADC_PAR_0 a0_sp;
            a0_sp.s_Type = wd_sp->t3.s_Type;
            a0_sp.FIFO = wd_sp->t3.FIFO;
            a0_sp.IrqStep = wd_sp->t3.IrqStep;
            a0_sp.Pages = wd_sp->t3.Pages;
            a0_sp.AutoInit = wd_sp->t3.AutoInit;
            a0_sp.dRate = wd_sp->t3.dRate;
            a0_sp.dKadr = wd_sp->t3.dKadr;
            a0_sp.dScale = wd_sp->t3.dScale;
            a0_sp.Rate = wd_sp->t3.Rate;
            a0_sp.Kadr = wd_sp->t3.Kadr;
            a0_sp.Scale = wd_sp->t3.Scale;
            a0_sp.FPDelay = wd_sp->t3.FPDelay;

            a0_sp.SynchroType = wd_sp->t3.SynchroType;
            a0_sp.SynchroSensitivity = wd_sp->t3.SynchroSensitivity;
            a0_sp.SynchroMode = wd_sp->t3.SynchroMode;
            a0_sp.AdChannel = wd_sp->t3.AdChannel;
            a0_sp.AdPorog = wd_sp->t3.AdPorog;
            a0_sp.NCh = wd_sp->t3.NCh;
            for(int i=0;i<128;i++) a0_sp.Chn[i] = wd_sp->t3.Chn[i];
            a0_sp.AdcEna = wd_sp->t3.AdcEna;
            a0_sp.IrqEna = wd_sp->t3.IrqEna;

            Err=((IDaqLDevice*)*hIfc)->FillDAQparameters(&a0_sp);
            wd_sp->t3.dRate = a0_sp.dRate;
            wd_sp->t3.dKadr = a0_sp.dKadr;
            wd_sp->t3.NCh = a0_sp.NCh;
         } break;
      case CASE_ADC_PAR_1:
         {
            ADC_PAR_1 a1_sp;
            a1_sp.s_Type = wd_sp->t4.s_Type;
            a1_sp.FIFO = wd_sp->t4.FIFO;
            a1_sp.IrqStep = wd_sp->t4.IrqStep;
            a1_sp.Pages = wd_sp->t4.Pages;
            a1_sp.AutoInit = wd_sp->t4.AutoInit;
            a1_sp.dRate = wd_sp->t4.dRate;
            a1_sp.dKadr = wd_sp->t4.dKadr;
            a1_sp.Reserved1 = wd_sp->t4.Reserved1;
            a1_sp.DigRate = wd_sp->t4.DigRate;
            a1_sp.DM_Ena = wd_sp->t4.DM_Ena;
            a1_sp.Rate = wd_sp->t4.Rate;
            a1_sp.Kadr = wd_sp->t4.Kadr;
            a1_sp.StartCnt = wd_sp->t4.StartCnt;
            a1_sp.StopCnt = wd_sp->t4.StopCnt;

            a1_sp.SynchroType = wd_sp->t4.SynchroType;
            a1_sp.SynchroMode = wd_sp->t4.SynchroMode;
            a1_sp.AdPorog = wd_sp->t4.AdPorog;
            a1_sp.SynchroSrc = wd_sp->t4.SynchroSrc;
            a1_sp.AdcIMask = wd_sp->t4.AdcIMask;
            a1_sp.NCh = wd_sp->t4.NCh;
            for(int i=0;i<128;i++) a1_sp.Chn[i] = wd_sp->t4.Chn[i];
            a1_sp.AdcEna = wd_sp->t4.AdcEna;
            a1_sp.IrqEna = wd_sp->t4.IrqEna;

            Err=((IDaqLDevice*)*hIfc)->FillDAQparameters(&a1_sp);
            wd_sp->t4.dRate = a1_sp.dRate;
            wd_sp->t4.dKadr = a1_sp.dKadr;
            wd_sp->t4.NCh = a1_sp.NCh;
         } break;
      }
      return Err;
}


DllExport(ULONG)  InitStartLDevice(PL_ULONG hIfc)
{
   return ((IDaqLDevice*)*hIfc)->InitStartLDevice();
}

DllExport(ULONG)  StartLDevice(PL_ULONG hIfc)
{
   return ((IDaqLDevice*)*hIfc)->StartLDevice();
}

DllExport(ULONG)  StopLDevice(PL_ULONG hIfc)
{
   return ((IDaqLDevice*)*hIfc)->StopLDevice();
}


DllExport(ULONG)  LoadBios(PL_ULONG hIfc, char *FileName)
{
   return ((IDaqLDevice*)*hIfc)->LoadBios(FileName);
}


DllExport(ULONG)  IoAsync(PL_ULONG hIfc, PWASYNC_PAR sp)  // collect all async io operations
{
   ASYNC_PAR t_sp;
   ULONG Err;

   t_sp.s_Type = sp->s_Type;

   t_sp.FIFO = sp->FIFO;
   t_sp.IrqStep = sp->IrqStep;
   t_sp.Pages = sp->Pages;

   t_sp.dRate = sp->dRate;
   t_sp.Rate = sp->Rate;
   t_sp.NCh = sp->NCh;
   for(int i=0;i<128;i++) t_sp.Chn[i] = sp->Chn[i];
   for(int j=0;j<128;j++) t_sp.Data[j] = sp->Data[j];
   t_sp.Mode = sp->Mode;

   Err=((IDaqLDevice*)*hIfc)->IoAsync(&t_sp);
   if(Err==L_SUCCESS)
   {
      sp->s_Type = t_sp.s_Type;

      sp->FIFO = t_sp.FIFO;
      sp->IrqStep = t_sp.IrqStep;
      sp->Pages = t_sp.Pages;

      sp->dRate = t_sp.dRate;
      sp->Rate = t_sp.Rate;
      sp->NCh = t_sp.NCh;
      for(int i=0;i<128;i++) sp->Chn[i] = t_sp.Chn[i];
      for(int j=0;j<128;j++) sp->Data[j] = t_sp.Data[j];
      sp->Mode = t_sp.Mode;
   }

   return Err;
}


DllExport(ULONG)  ReadPlataDescr(PL_ULONG hIfc, LPVOID pd)
{
   return ((IDaqLDevice*)*hIfc)->ReadPlataDescr(pd);
}


DllExport(ULONG)  WritePlataDescr(PL_ULONG hIfc, LPVOID pd, USHORT Ena)
{
   return ((IDaqLDevice*)*hIfc)->WritePlataDescr(pd, Ena);
}


DllExport(ULONG)  ReadFlashWord(PL_ULONG hIfc, USHORT FlashAddress, PUSHORT Data)
{
   return ((IDaqLDevice*)*hIfc)->ReadFlashWord(FlashAddress, Data);
}

DllExport(ULONG)  WriteFlashWord(PL_ULONG hIfc, USHORT FlashAddress, USHORT Data)
{
   return ((IDaqLDevice*)*hIfc)->WriteFlashWord(FlashAddress, Data);
}

DllExport(ULONG)  EnableFlashWrite(PL_ULONG hIfc, USHORT Flag)
{
   return ((IDaqLDevice*)*hIfc)->EnableFlashWrite(Flag);
}

DllExport(ULONG)  EnableCorrection(PL_ULONG hIfc, USHORT Ena)
{
   return ((IDaqLDevice*)*hIfc)->EnableCorrection(Ena);
}

DllExport(ULONG)  GetParameter(PL_ULONG hIfc, ULONG name, PULONG param)
{
   return ((IDaqLDevice*)*hIfc)->GetParameter(name, param);
}

DllExport(ULONG)  SetParameter(PL_ULONG hIfc, ULONG name, PULONG param)
{
   return ((IDaqLDevice*)*hIfc)->SetParameter(name, param);
}

DllExport(ULONG)  SetLDeviceEvent(PL_ULONG hIfc, L_ULONG hEvent,ULONG EventId)
{
   return ((IDaqLDevice*)*hIfc)->SetLDeviceEvent((HANDLE)hEvent,EventId);
}


// For LabView

DllExport(ULONG) GetSyncData(PL_ULONG hIfc, L_ULONG SyncPtr, ULONG Offset, ULONG *Sync)
{
   ULONG s;
   InterlockedExchange(&s,*((PULONG)SyncPtr));
   *Sync = s; //((PULONG)SyncPtr)[Offset];
   return 0;
}

//   
//    ,     DWORD ...
DllExport(ULONG) GetDataFromBuffer(PL_ULONG hIfc, L_ULONG DataPtr, LPVOID DataArray, ULONG size, ULONG mask)
{
   UCHAR *D;
   D = (PUCHAR)DataArray;
//   memcpy(DataArray,(LPVOID)DataPtr,size*sizeof(UCHAR));
   for(ULONG j=0; j<size; j++) D[j] = ((PUCHAR)DataPtr)[j];
//     32  ....
   ULONG *DA;
   DA = (PULONG)DataArray;
   if(mask)
      for(ULONG i=0; i<size/sizeof(ULONG); i++) DA[i] = DA[i] & mask;
   return 0;
}

//   
DllExport(ULONG) PutDataToBuffer(PL_ULONG hIfc, L_ULONG DataPtr, LPVOID DataArray, ULONG size)
{
   memcpy((LPVOID)DataPtr,DataArray,size*sizeof(UCHAR));
   return 0;
}


DllExport(LPVOID) Get_LDEV2_Interface(PL_ULONG hIfc, PULONG Err) // return handle for new iface
{
   *Err = L_SUCCESS;
   IDaqLDevice2* pI;
   HRESULT hr = ((IDaqLDevice*)*hIfc)->QueryInterface(IID_ILDEV2,(void**)&pI);
   if(!SUCCEEDED(hr)) { *Err = L_ERROR; /*("Get IDaqLDevice failed");*/ return NULL; }
   return pI;
}

DllExport(ULONG)  InitStartLDeviceEx(PL_ULONG hIfc, ULONG StreamId)
{
   return ((IDaqLDevice2*)*hIfc)->InitStartLDeviceEx(StreamId);
}

DllExport(ULONG)  StartLDeviceEx(PL_ULONG hIfc, ULONG StreamId)
{
   return ((IDaqLDevice2*)*hIfc)->StartLDeviceEx(StreamId);
}

DllExport(ULONG)  StopLDeviceEx(PL_ULONG hIfc, ULONG StreamId)
{
   return ((IDaqLDevice2*)*hIfc)->StopLDeviceEx(StreamId);
}

DllExport(ULONG)  Release_LDEV2_Interface(PL_ULONG hIfc)
{
  ((IDaqLDevice2*)*hIfc)->Release();
  return L_SUCCESS;
}
