#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <objbase.h>

using namespace std;

#include <math.h>
#include "..\include\ioctl.h"
#include "..\include\wlcomp.h"


ULONG hIfc;
ULONG   *fdata=0, *fdata1=0;
HANDLE hFile=0, hMap=0, hFile1=0, hMap1=0;
long fsize,k;

ULONG *data, *data1;
ULONG *sync, *sync1;

ULONG status;
USHORT complete;

USHORT FIFO = 1024;   //       -    1  128,     128
USHORT IrqStep = 1024;// 
USHORT pages = 128;   // IrqSetp*pages       , 
                      //        128    128 



int main(int argc, char *argv[])
{
ULONG hDll;
ULONG Err;
WDAQ_PAR dacPar;
PLATA_DESCR_U2 pd;
SLOT_PAR sl;
ULONG slot = 0;  //

   if(argc==1)
   {
      cout << "L-791 simple sin generator (5 kHz max) (using wlcomp.dll)." << endl;
      cout << "(c) 2009 L-Card." << endl;
      cout << "Usage:" << endl;
      cout << "   client <freq kHz>" << endl;
      exit(1);
   }
   if(argc<2)
   {
      cout << "no params - exit!" << endl;
      exit(1);
   }


   hDll = LoadAPIDLL("lcomp.dll");
//      791
   ULONG err = 1;
   do
   {
      hIfc = (ULONG)CallCreateInstance(&hDll,slot,&Err);
      if(Err) { cout << "CallCreateInstance failed" << endl; err=2; break; }
   
      //  
      if(OpenLDevice(&hIfc)==(-1)) { err=2; break;}
      if(GetSlotParam(&hIfc,&sl)) { err=2; break;}
      if(sl.BoardType==L791) { cout <<"Found L791 in slot " << slot << endl; err=0;}
      else
      {  
         slot++;
         if(CloseLDevice(&hIfc)) { err=2; break;}
      }
   } while(err);

   if(err==2) {cout << "No L-791 board in PC or somting wrong.... Program exit..." << endl; exit(0); }


   err = 1;
   do
   {
      if(PlataTest(&hIfc)) break; //      return 0 - nr     
      if(ReadPlataDescr(&hIfc,&pd)) break; //    

      cout << endl;
      cout << "SerNum " << pd.t3.SerNum << endl;
      cout << "BrdName " << pd.t3.BrdName << endl;
      cout << "Rev " << pd.t3.Rev << endl;
      cout << "DspType " << pd.t3.DspType << endl;
      cout << "IsDacPresent " << pd.t3.IsDacPresent << endl;
      cout << "Quartz " << pd.t3.Quartz << endl;


   //  
   //              
      dacPar.t2.s_Type = L_DAC_PARAM;
      dacPar.t2.AutoInit=1;
      dacPar.t2.dRate=125.0;
      dacPar.t2.FIFO=1024;
      dacPar.t2.IrqStep=1024;
      dacPar.t2.Pages=128;
      dacPar.t2.IrqEna=1;
      dacPar.t2.DacEna=1;

      double Freal,Forig,Fdelta; Fdelta=Forig=atof(argv[1]);
      int pppreal;
      double rdRate;
      for(int j=125;j>(int)(Forig*10);j--)
      {
         dacPar.t2.dRate=j;
         FillDAQparameters(&hIfc, &dacPar, 1);

   
         int ppp = (int)(dacPar.t2.dRate/Forig);
         int pppdelta=ppp,ppptemp;
         int pppr = 0;
         for(int k=2; k<4*ppp; k++)
         {
            if((128*1024%k)==0)
            {
               ppptemp = abs(ppp-k);
               if(ppptemp<=pppdelta) { pppr = k; pppdelta=ppptemp; }
            }
         }
         double Freq = dacPar.t2.dRate/pppr;
         if(abs(int((Freq-Forig)*1000))<int(Fdelta*1000)) { Freal=Freq; pppreal = pppr; Fdelta=abs(Freq-Forig); rdRate=dacPar.t2.dRate;}
      }

      cout << "Real freq " << Freal  << " kHz"<< endl;
      cout << "Real ppp " << pppreal  << " points"<< endl;
      cout << "Real dRate " << rdRate  << " kHz"<< endl;

      dacPar.t2.dRate=rdRate;
      FillDAQparameters(&hIfc, &dacPar, 1);

      ULONG db=512000;
      RequestBufferStream(&hIfc, &db, L_STREAM_DAC);
      SetParametersStream(&hIfc, &dacPar, 1,&db, (void **)&data1, (void **)&sync1,L_STREAM_DAC);

      //  
      ULONG *td = new ULONG[128*1024];

      int i = 0;
      do
      {
         td[i] = (((USHORT)(512.0*sin(2.0*3.1415926*i/pppreal))&0xFFF))<<16 | (1<<28);
         if(((i+1)%1024)==0) { td[i] |= (1<<31); cout << " i " << i;}
         i++;
      } while(i<128*1024);

      ULONG par;
      GetParameter(&hIfc, L_DATA1_ADDR_LO, &par); // 10008

      PutDataToBuffer(&hIfc, par, td, 128*1024*sizeof(ULONG));

      delete[] td;
///////////

      cout << "Started ..." << endl;

      //    
      InitStartLDevice(&hIfc);

      //    
      status=StartLDevice(&hIfc);

      //    
      while(!kbhit())
      {
         Sleep(20);
      }
      _getch();
      cout << "StartLDevice returned " << (status ? "TRUE":"FALSE") << endl;

      StopLDevice(&hIfc); //  

      err = 0;
   } while(err);

   CloseLDevice(&hIfc);

   cout << "Exit" << endl;
   return 0;
}
