#define INITGUID

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <iomanip>
#include <objbase.h>

using namespace std;

#include <math.h>

#include "..\include\ioctl.h"
#include "..\include\ifc_ldev.h"
#include "..\include\791cmd.h"


typedef IDaqLDevice* (*CREATEFUNCPTR)(ULONG Slot);

CREATEFUNCPTR CreateInstance;

HINSTANCE CallCreateInstance(char* name)
{
   HINSTANCE hComponent = ::LoadLibrary(name);
   if(hComponent==NULL) { return 0; }

   CreateInstance = (CREATEFUNCPTR)::GetProcAddress(hComponent,"CreateInstance");
   if(CreateInstance==NULL) { return 0; }
   return hComponent;
}


ULONG   *fdata=0, *fdata1=0;
HANDLE hFile=0, hMap=0, hFile1=0, hMap1=0;
long fsize,k;

ULONG *data, *data1;
ULONG *sync, *sync1;

ULONG status;
USHORT complete;

HANDLE hThread;
ULONG Tid;


USHORT FIFO = 1024;   //       -    1  128,     128
USHORT IrqStep = 1024;// 
USHORT pages = 128;   // IrqSetp*pages       , 
                      //        128    128 



int main(int argc, char *argv[])
{
DAC_PAR dacPar;
PLATA_DESCR_L791 pd;
SLOT_PAR sl;

IDaqLDevice* pI;
ULONG slot = 0;  //

   if(argc==1)
   {
      cout << "L-791 simple sin generator (5 kHz max)." << endl;
      cout << "(c) 2010 L-Card." << endl;
      cout << "Usage:" << endl;
      cout << "   client <freq kHz>" << endl;
      exit(1);
   }
   if(argc<2)
   {
      cout << "no params - exit!" << endl;
      exit(1);
   }
  
//      791
   CallCreateInstance("lcomp.dll");
   ULONG err = 1;
   do
   {
      LUnknown* pIUnknown = CreateInstance(slot);
      if(pIUnknown == NULL) { cout << "CallCreateInstance failed" << endl; err=2; break; }
   
      HRESULT hr = pIUnknown->QueryInterface(IID_ILDEV,(void**)&pI);
      if(!SUCCEEDED(hr)) { cout << "Get IDaqLDevice failed" << endl; err=2; break; }
      pIUnknown->Release();

      //  
      if(pI->OpenLDevice()==INVALID_HANDLE_VALUE) { err=2; break;}
      if(pI->GetSlotParam(&sl)) { err=2; break;}
      if(sl.BoardType==L791) { cout <<"Found L791 in slot " << slot << endl; err=0;}
      else
      {  
         slot++;
         if(pI->CloseLDevice()) { err=2; break;}
         pI->Release();
      }
   } while(err);

   if(err==2) {cout << "No L-791 board in PC or something wrong.... Program exit..." << endl; exit(0); }


   err = 1;
   do
   {
      if(pI->PlataTest()) break; //      return 0 - nr     
      if(pI->ReadPlataDescr(&pd)) break; //    

      cout << endl;
      cout << "SerNum " << pd.SerNum << endl;
      cout << "BrdName " << pd.BrdName << endl;
      cout << "Rev " << pd.Rev << endl;
      cout << "DspType " << pd.DspType << endl;
      cout << "IsDacPresent " << pd.IsDacPresent << endl;
      cout << "Quartz " << pd.Quartz << endl;


   //  
   //              
      dacPar.t2.s_Type = L_DAC_PARAM;
      dacPar.t2.AutoInit=1;
      dacPar.t2.dRate=125.0;
      dacPar.t2.FIFO=1024;
      dacPar.t2.IrqStep=1024;
      dacPar.t2.Pages=128;
      dacPar.t2.IrqEna=1;
      dacPar.t2.DacEna=1;

      double Freal,Forig,Fdelta; Fdelta=Forig=atof(argv[1]);
      int pppreal;
      double rdRate;
      for(int j=125;j>(int)(Forig*10);j--)
      {
         dacPar.t2.dRate=j;
         pI->FillDAQparameters(&dacPar.t2);
   
         int ppp = (int)(dacPar.t2.dRate/Forig);
         int pppdelta=ppp,ppptemp;
         int pppr = 0;
         for(int k=2; k<4*ppp; k++)
         {
            if((128*1024%k)==0)
            {
               ppptemp = abs(ppp-k);
               if(ppptemp<=pppdelta) { pppr = k; pppdelta=ppptemp; }
            }
         }
         double Freq = dacPar.t2.dRate/pppr;
         if(abs(int((Freq-Forig)*1000))<int(Fdelta*1000)) { Freal=Freq; pppreal = pppr; Fdelta=abs(Freq-Forig); rdRate=dacPar.t2.dRate;}
      }

      cout << "Real freq " << Freal  << " kHz"<< endl;
      cout << "Real ppp " << pppreal  << " points"<< endl;
      cout << "Real dRate " << rdRate  << " kHz"<< endl;

      dacPar.t2.dRate=rdRate;
      pI->FillDAQparameters(&dacPar.t2);

      ULONG db=512000;
      pI->RequestBufferStream(&db, L_STREAM_DAC);
      pI->SetParametersStream(&dacPar.t2,&db, (void **)&data1, (void **)&sync1,L_STREAM_DAC);


      int i = 0;
      do
      {
         data1[i] = (((USHORT)(512.0*sin(2.0*3.1415926*i/pppreal))&0xFFF))<<16 | (1<<28);
         if(((i+1)%1024)==0) { data1[i] |= (1<<31); cout << " i " << i;}
         i++;
      } while(i<128*1024);

///////////

      cout << "Started ..." << endl;

      //    
      pI->InitStartLDevice();

      //    
      status=pI->StartLDevice();

      //    
      while(!kbhit())
      {
         ULONG s;
         InterlockedExchange(&s,*sync1);
         cout << ".......... " << setw(6) << s << "\r";

         Sleep(20);
      }
      _getch();
      cout << "StartLDevice returned " << (status ? "L_ERROR":"L_SUCCESS") << endl;

      pI->StopLDevice(); //  

      err = 0;
   } while(err);

end :

   pI->CloseLDevice();
   pI->Release();

   cout << "Exit" << endl;
   return 0;
}
