

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ifc_ldev,ioctl,
  StdCtrls, ExtCtrls, SyncObjs, create, e440cmd, e140cmd, e2010cmd, cmd791;


const
   FIFO = 1024;
   IrqStep = 1024;
   pages = 128;
   slot = 1; {      .      0}

type
  WA = array [0..1048576] of SHORT;
  PWA = ^WA;



type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Timer1: TTimer;
    Timer2: TTimer;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  pLDev: IDaqLDevice;
  pIUnknown:LUnknown;
  hr:Integer;
  sl:SLOT_PAR;
  dev: THandle;
  pd: PLATA_DESCR_U2;
  ap: ADC_PAR;
  tm: ULONG;
  data:PWA;
  sync:PULONG;
  LockXY : TCriticalSection;
  skip: Integer;
implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var s:string;
    pp:ASYNC_PAR;

begin

   pLDev.GetSlotParam(sl);

   Memo1.Lines.Add('');
   Memo1.Lines.Add('Slot parameters');
   Memo1.Lines.Add('Base - '+IntToHex(sl.Base,4));
   Memo1.Lines.Add('BaseL - '+IntToHex(sl.BaseL,4));
   Memo1.Lines.Add('Mem - '+IntToHex(sl.Mem,8));
   Memo1.Lines.Add('MemL - '+IntToHex(sl.MemL,8));
   Memo1.Lines.Add('Type - '+IntToStr(sl.BoardType));
   Memo1.Lines.Add('DSPType - '+IntToStr(sl.DSPType));
   Memo1.Lines.Add('Irq - '+IntToStr(sl.Irq));
   Memo1.Lines.Add('');


   case sl.BoardType of
   PCIA,PCIB,PCIC:
        begin
           s:=IntToStr(pLDev.ReadPlataDescr(pd));
           Memo1.Lines.Add('ReadPlataDescr status '+s);
           s:=IntToStr(pLDev.LoadBios(pd.t1.BrdName));
           Memo1.Lines.Add('LoadBios status '+s);

           Memo1.Lines.Add('');
           Memo1.Lines.Add('Serial Num. '+pd.t1.SerNum);
           Memo1.Lines.Add('Board Name '+pd.t1.BrdName);
           Memo1.Lines.Add('Revision '+pd.t1.Rev);
           Memo1.Lines.Add('DSP Type '+pd.t1.DspType);
           Memo1.Lines.Add('Quartz '+IntToStr(pd.t1.Quartz));
        end;
   E440:
        begin
           s:=IntToStr(pLDev.LoadBios('e440'));
           Memo1.Lines.Add('LoadBios status '+s);
           s:=IntToStr(pLDev.ReadPlataDescr(pd));
           Memo1.Lines.Add('ReadPlataDescr status '+s);

           Memo1.Lines.Add('');
           Memo1.Lines.Add('Serial Num. '+pd.t4.SerNum);
           Memo1.Lines.Add('Board Name '+pd.t4.BrdName);
           Memo1.Lines.Add('Revision '+pd.t4.Rev);
           Memo1.Lines.Add('DSP Type '+pd.t4.DspType);
           Memo1.Lines.Add('Quartz '+IntToStr(pd.t4.Quartz));
        end;
   E140:
        begin
           s:=IntToStr(pLDev.LoadBios('e440'));          {no bios needed}
           Memo1.Lines.Add('LoadBios status '+s);
           s:=IntToStr(pLDev.ReadPlataDescr(pd));
           Memo1.Lines.Add('ReadPlataDescr status '+s);

           Memo1.Lines.Add('');
           Memo1.Lines.Add('Serial Num. '+pd.t5.SerNum);
           Memo1.Lines.Add('Board Name '+pd.t5.BrdName);
           Memo1.Lines.Add('Revision '+pd.t5.Rev);
           Memo1.Lines.Add('DSP Type '+pd.t5.DspType);
           Memo1.Lines.Add('Quartz '+IntToStr(pd.t5.Quartz));
        end;
   E154:
        begin
           s:=IntToStr(pLDev.LoadBios('e440'));          {no bios needed}
           Memo1.Lines.Add('LoadBios status '+s);
           s:=IntToStr(pLDev.ReadPlataDescr(pd));
           Memo1.Lines.Add('ReadPlataDescr status '+s);

           Memo1.Lines.Add('');
           Memo1.Lines.Add('Serial Num. '+pd.t7.SerNum);
           Memo1.Lines.Add('Board Name '+pd.t7.BrdName);
           Memo1.Lines.Add('Revision '+pd.t7.Rev);
           Memo1.Lines.Add('DSP Type '+pd.t7.DspType);
           Memo1.Lines.Add('Quartz '+IntToStr(pd.t7.Quartz));
        end;
   E2010B:
        begin
           s:=IntToStr(pLDev.LoadBios('e2010m'));
           Memo1.Lines.Add('LoadBios status '+s);
           s:=IntToStr(pLDev.ReadPlataDescr(pd));
           Memo1.Lines.Add('ReadPlataDescr status '+s);

           Memo1.Lines.Add('');
           Memo1.Lines.Add('Serial Num. '+pd.t6.SerNum);
           Memo1.Lines.Add('Board Name '+pd.t6.BrdName);
           Memo1.Lines.Add('Revision '+pd.t6.Rev);
           Memo1.Lines.Add('DSP Type '+pd.t6.DspType);
           Memo1.Lines.Add('Quartz '+IntToStr(pd.t6.Quartz));
        end;

   E2010:
        begin
           s:=IntToStr(pLDev.LoadBios('e2010'));
           Memo1.Lines.Add('LoadBios status '+s);
           s:=IntToStr(pLDev.ReadPlataDescr(pd));
           Memo1.Lines.Add('ReadPlataDescr status '+s);

           Memo1.Lines.Add('');
           Memo1.Lines.Add('Serial Num. '+pd.t6.SerNum);
           Memo1.Lines.Add('Board Name '+pd.t6.BrdName);
           Memo1.Lines.Add('Revision '+pd.t6.Rev);
           Memo1.Lines.Add('DSP Type '+pd.t6.DspType);
           Memo1.Lines.Add('Quartz '+IntToStr(pd.t6.Quartz));
        end;

   end;

   s:= IntToStr(pLDev.PlataTest);
   Memo1.Lines.Add('PlataTest status '+s);

{        IoSaync }
   pp.s_Type := L_ASYNC_TTL_CFG;
   pp.Mode := 1;
   pLDev.IoAsync(pp);

   pp.s_Type := L_ASYNC_TTL_OUT;
   pp.Data[0] := $A525;
   pLDev.IoAsync(pp);

   pp.s_Type := L_ASYNC_TTL_INP;
   pp.Data[0] := 1;
   pLDEv.IoAsync(pp);

   Memo1.Lines.Add('');
   Memo1.Lines.Add('IoAsync call');
   Memo1.Lines.Add('Data[0] - '+IntToStr(pp.Data[0]));

end;

procedure TForm1.Button2Click(Sender: TObject);
begin

   tm := 1024*1024;  //   1M 
   pLDev.RequestBufferStream(tm,L_STREAM_ADC);
   Memo1.Lines.Add('Allocated memory size(word) : '+IntToStr(tm));

   case sl.BoardType of
   PCIA,PCIB,PCIC,E440,E140,E154:
      begin
         ap.t1.s_Type := L_ADC_PARAM;
         ap.t1.AutoInit := 1;
         ap.t1.dRate := 400.0;
         ap.t1.dKadr := 0.0;
         ap.t1.dScale := 0;
         ap.t1.SynchroType := 3;
         if((sl.BoardType = E440) or (sl.BoardType=E140) or (sl.BoardType=E154)) then ap.t1.SynchroType := 0;//0
         ap.t1.SynchroSensitivity := 0;
         ap.t1.SynchroMode := 0;
         ap.t1.AdChannel := 0;
         ap.t1.AdPorog := 0;
         ap.t1.NCh := 16;
         ap.t1.Chn[0] := $0;
         ap.t1.Chn[1] := $1;
         ap.t1.Chn[2] := $2;
         ap.t1.Chn[3] := $3;
         ap.t1.FIFO := FIFO;
         ap.t1.IrqStep := IrqStep;
         ap.t1.Pages := pages;
         if((sl.BoardType=E440) or (sl.BoardType=E140) or (sl.BoardType=E154)) then
         begin
            ap.t1.FIFO := 4096;
            ap.t1.IrqStep := 4096;
            ap.t1.Pages := 32;
         end;

         ap.t1.IrqEna := 1;
         ap.t1.AdcEna := 1;

         pLDev.FillDAQparameters(ap.t1);
         pLDev.SetParametersStream(ap.t1, tm, data, sync,L_STREAM_ADC);

         Memo1.Lines.Add('Buffer size(word): '+IntToStr(tm));
         Memo1.Lines.Add('Pages: '+IntToStr(ap.t1.Pages));
         Memo1.Lines.Add('Rate: '+FloatToStr(ap.t1.dRate));
      end;

   E2010B,E2010:
      begin
         ap.t2.s_Type := L_ADC_PARAM;
         ap.t2.AutoInit := 1;
         ap.t2.dRate := 5000.0;
         ap.t2.dKadr := 0.01;
         ap.t2.SynchroType := $1;
         ap.t2.SynchroSrc := $0;
         ap.t2.AdcIMask := SIG_0 or SIG_1 or SIG_2 or SIG_3;

         ap.t2.NCh := 4;
         ap.t2.Chn[0] := $0;
         ap.t2.Chn[1] := $1;
         ap.t2.Chn[2] := $2;
         ap.t2.Chn[3] := $3;
         ap.t2.FIFO := 32768;
         ap.t2.IrqStep := 32768;
         ap.t2.Pages := 32;
         ap.t2.IrqEna := 1;
         ap.t2.AdcEna := 1;

         // extra sync mode
         ap.t2.StartCnt := 0;
         ap.t2.StopCnt := 0;
         ap.t2.DM_Ena := 1;
         ap.t2.SynchroMode := A_SYNC_UP_EDGE or CH_0;
         ap.t2.AdPorog := 1;

         pLDev.FillDAQparameters(ap.t2);
         pLDev.SetParametersStream(ap.t2, tm, data, sync,L_STREAM_ADC);
         Memo1.Lines.Add('Buffer size(word): '+IntToStr(tm));
         Memo1.Lines.Add('Pages: '+IntToStr(ap.t2.Pages));
         Memo1.Lines.Add('Rate: '+FloatToStr(ap.t2.dRate));
      end;

   end;

   Timer1.Enabled:=True;
   Timer2.Enabled:=True;
   pLDev.InitStartLDevice;
   pLDev.StartLDevice;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  skip:=1;
   Timer1.Enabled:=False;
   Timer2.Enabled:=False;

   LockXY:= TCriticalSection.Create;

   Memo1.Lines.Clear;
   Memo1.Lines.Add('Testing library');
   if(CallCreateInstance('lcomp.dll')=1) then
   begin
      Memo1.Lines.Add('Loading library - success.');
      Memo1.Lines.Add('');
   end;
{         }
   pIUnknown:=CreateInstance(slot);
   hr := pIUnknown.QueryInterface(IID_ILDEV,pLDev);
   if(not Succeeded(hr)) then MessageBox(0,'Get interface failed','Error',MB_OK);
   pIUnknown.Release;
   dev:=pLDev.OpenLDevice;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   data:=NIL;
   sync:=NIL;
   Timer1.Enabled:=False;
   Timer2.Enabled:=False;
   pLDev.StopLDevice;
   pLDev.CloseLDevice;
   pLDev.Release;
   LockXY.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   if((data<>NIL) and (sync<>NIL)) then
      Memo1.Lines.Add('Sync: '+IntToStr(sync^) + ' ' +IntToStr(data[0])+' ' +IntToStr(data[128])+' ' +IntToStr(data[1024]) + ' ' + IntToStr(skip));
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var pp:ASYNC_PAR;

begin
  LockXY.Acquire; { lock out other threads }
  try
    pp.s_Type := L_ASYNC_TTL_OUT;
    pp.Data[0] := $A525;
    pLDev.IoAsync(pp);

    pp.s_Type := L_ASYNC_TTL_INP;
    pp.Data[0] := 1;
    pLDEv.IoAsync(pp);
    skip := skip+1;
  finally
    LockXY.Release;
  end;
//    Label1.Caption := IntToStr(trunc(GetTickCount()/1000.0))+': ' + IntToStr(pp.Data[0])+ ': '+IntToStr(skip);
end;

end.
