#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "..\include\ioctl.h"
#include "..\include\wlcomp.h"
#include "..\include\e2010cmd.h"


ULONG hIfc;

USHORT   *fdata;
HANDLE hFile, hMap;
long fsize;

USHORT *data;
ULONG *sync;


ULONG status;
ULONG complete;

HANDLE hThread;
ULONG Tid;

ULONG IrqStep = 2048;//777-777%7; //     
ULONG FIFO = 2048;         //
ULONG pages = 32;
ULONG multi = 8; // -    ,    


//      
#pragma optimize ("", off)
ULONG WINAPI ServiceThread(PVOID Context)
{
   ULONG halfbuffer = IrqStep*pages/2;             //    
   ULONG syncd;
   ULONG i;
   ULONG fl1,fl2;
   USHORT *tmp,*tmp1;
   
   GetSyncData(&hIfc, (ULONG)sync, 0, &syncd);
   fl1 = fl2 = (syncd<=halfbuffer)? 0:1; //  

   for(i=0;i<multi;i++)                        //     
   {
      while(fl2==fl1)
      {
         if(InterlockedCompareExchange(&complete,3,3)) return 0;
         GetSyncData(&hIfc, (ULONG)sync, 0, &syncd);
         fl2=(syncd<=halfbuffer)? 0:1; //    
      }
      tmp=fdata+(halfbuffer*i);                    //    
      tmp1=data+(halfbuffer*fl1);                  //     

      //memcpy(tmp,tmp1,halfbuffer*sizeof(USHORT));//    
      GetDataFromBuffer(&hIfc, (ULONG)tmp1, tmp, halfbuffer*sizeof(USHORT),0);

      GetSyncData(&hIfc, (ULONG)sync, 0,&syncd);
      fl1=(syncd<=halfbuffer)? 0:1;                //  
      Sleep(0);                                    //        
   }
   return 0;                                          // 
}
#pragma optimize ("", on)


int main(int argc, char *argv[])
{
ULONG hDll;
ULONG Err;
WDAQ_PAR adcPar;
PLATA_DESCR_U2 pd;
SLOT_PAR sl;
ULONG slot = 0;
ULONG tm;

   if(argc==1)
   {
      printf("WLCOMP simple example (L761,L780,L783,E440,E140,E2010). \n");
      printf("(c) 2013 L-Card. \n");
      printf("Usage: \n");
      printf("   client <slot number> <bios name> \n");
      printf("   <slot number> - 0... (if one board installed - 0); \n");
      printf("   <bios name>  - bios name without extension(l761 l780 l783); \n");
      exit(1);
   }
   if(argc<3)
   {
      printf("no params - exit! \n");
      exit(1);
   }

   hDll = LoadAPIDLL("lcomp.dll");

   hIfc = (ULONG)CallCreateInstance(&hDll, atoi(argv[1]),&Err); // return handle for new iface

   Err = OpenLDevice(&hIfc);
   printf("OpenLDevice Handle %x \n",Err);
   Err = LoadBios(&hIfc, argv[2]);
   printf("LoadBios status %x \n",Err);
   Err = PlataTest(&hIfc);
   printf("Plata test %x \n",Err);

   printf("\n Slot parameters \n");   
   GetSlotParam(&hIfc, &sl);

   printf("Base    %x \n", sl.Base);
   printf("BaseL   %x \n", sl.BaseL);
   printf("Mem     %x \n", sl.Mem);
   printf("MemL    %x \n", sl.MemL);
   printf("Type    %x \n", sl.BoardType);
   printf("DSPType %x \n", sl.DSPType);
   printf("Irq     %x \n", sl.Irq);

   printf("\n Press any key \n");
   _getch();

   printf("\n Read FLASH \n");

   ReadPlataDescr(&hIfc, &pd); // fill up properties

   switch (sl.BoardType)
   {
   case PCIA:
   case PCIB:
   case PCIC:  {
                  printf("SerNum       %s \n", pd.t1.SerNum);
                  printf("BrdName      %s \n", pd.t1.BrdName);
                  printf("Rev          %c \n", pd.t1.Rev);
                  printf("DspType      %s \n", pd.t1.DspType);
                  printf("IsDacPresent %x \n", pd.t1.IsDacPresent);
                  printf("Quartz       %d \n", pd.t1.Quartz);
               } break;
   case E140:  {
                  printf("SerNum       %s \n", pd.t5.SerNum);
                  printf("BrdName      %s \n", pd.t5.BrdName);
                  printf("Rev          %c \n", pd.t5.Rev);
                  printf("DspType      %s \n", pd.t5.DspType);
                  printf("IsDacPresent %x \n", pd.t5.IsDacPresent);
                  printf("Quartz       %d \n", pd.t5.Quartz);
               } break;
   case E154:  {
                  printf("SerNum       %s \n", pd.t7.SerNum);
                  printf("BrdName      %s \n", pd.t7.BrdName);
                  printf("Rev          %c \n", pd.t7.Rev);
                  printf("DspType      %s \n", pd.t7.DspType);
                  printf("IsDacPresent %x \n", pd.t7.IsDacPresent);
                  printf("Quartz       %d \n", pd.t7.Quartz);
               } break;
   
   case E440:  {
                  printf("SerNum       %s \n", pd.t4.SerNum);
                  printf("BrdName      %s \n", pd.t4.BrdName);
                  printf("Rev          %c \n", pd.t4.Rev);
                  printf("DspType      %s \n", pd.t4.DspType);
                  printf("IsDacPresent %x \n", pd.t4.IsDacPresent);
                  printf("Quartz       %d \n", pd.t4.Quartz);
               } break;
   case E2010B:
   case E2010: {
                  printf("SerNum       %s \n", pd.t6.SerNum);
                  printf("BrdName      %s \n", pd.t6.BrdName);
                  printf("Rev          %c \n", pd.t6.Rev);
                  printf("DspType      %s \n", pd.t6.DspType);
                  printf("IsDacPresent %x \n", pd.t6.IsDacPresent);
                  printf("Quartz       %d \n", pd.t6.Quartz);
               }
   }

   printf("\n Press any key \n");
   _getch();



// digital line test IoAsync example call
/*
   WASYNC_PAR pp;

   pp.s_Type = L_ASYNC_TTL_OUT;
   pp.Data[0] = 0xA525;
   cout << IoAsync(&hIfc, &pp) << endl;

   pp.s_Type = L_ASYNC_TTL_INP;
   pp.Data[0] = 1;
   cout << IoAsync(&hIfc, &pp) << endl;

   cout << "TTL input " << hex << pp.Data[0] << endl;  
   cout << endl << "TTL io test " << dec << endl;
*/
   tm = 10000000;

   RequestBufferStream(&hIfc, &tm, L_STREAM_ADC);
   printf("Allocated memory size(word): %d \n", tm);

   //   
   switch(sl.BoardType)
   {
   case PCIA:
   case PCIB:
   case PCIC:
   case E440:
   case E140:
   case E154:
      {
         adcPar.t3.s_Type = L_ADC_PARAM;
         adcPar.t3.AutoInit = 1;
         adcPar.t3.dRate = 100.0;
         adcPar.t3.dKadr = 0;
         adcPar.t3.dScale = 0;
         adcPar.t3.SynchroType = 3;
         if(sl.BoardType==E440 || sl.BoardType==E140 || sl.BoardType==E154) adcPar.t3.SynchroType = 0;
         adcPar.t3.SynchroSensitivity = 0;
         adcPar.t3.SynchroMode = 0;
         adcPar.t3.AdChannel = 0;
         adcPar.t3.AdPorog = 0;
         adcPar.t3.NCh = 4;
         adcPar.t3.Chn[0] = 0x0;
         adcPar.t3.Chn[1] = 0x1;
         adcPar.t3.Chn[2] = 0x2;
         adcPar.t3.Chn[3] = 0x3;
         adcPar.t3.FIFO = 1024;
         adcPar.t3.IrqStep = 1024;
         adcPar.t3.Pages = 128;
         if(sl.BoardType==E440 || sl.BoardType==E140 || sl.BoardType==E154)
         {
            adcPar.t3.FIFO = 4096;
            adcPar.t3.IrqStep = 4096;
            adcPar.t3.Pages = 32;
         }
         adcPar.t3.IrqEna = 1;
         adcPar.t3.AdcEna = 1;

         FillDAQparameters(&hIfc, &adcPar, CASE_ADC_PAR_0);
         SetParametersStream(&hIfc, &adcPar, CASE_ADC_PAR_0, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

         printf("Buffer size(points): %d \n" ,tm);
         printf("Pages:             %d \n" ,adcPar.t3.Pages);
         printf("IrqStep:           %d \n" ,adcPar.t3.IrqStep);
         printf("FIFO:              %d \n" ,adcPar.t3.FIFO);
         printf("Rate:              %f \n" ,adcPar.t3.dRate);
         printf("Kadr:              %f \n" ,adcPar.t3.dKadr);

         IrqStep = adcPar.t3.IrqStep;
         pages = adcPar.t3.Pages;

      } break;

   case E2010B:
   case E2010:
      {
         adcPar.t4.s_Type = L_ADC_PARAM;
         adcPar.t4.AutoInit = 1;
         adcPar.t4.dRate = 1000.0;
         adcPar.t4.dKadr = 0.001;
         adcPar.t4.SynchroType = 0x01;
         adcPar.t4.AdcIMask = SIG_0|SIG_1|SIG_2|SIG_3;
         
         adcPar.t4.NCh = 4;
         adcPar.t4.Chn[0] = 0x0;
         adcPar.t4.Chn[1] = 0x1;
         adcPar.t4.Chn[2] = 0x2;
         adcPar.t4.Chn[3] = 0x3;
         adcPar.t4.FIFO = 32768;
         adcPar.t4.IrqStep = 32768;
         adcPar.t4.Pages = 32;
         adcPar.t4.IrqEna = 1;
         adcPar.t4.AdcEna = 1;

         FillDAQparameters(&hIfc, &adcPar.t4, CASE_ADC_PAR_1);
         printf("Buffer size(word): %d \n" ,tm);
         printf("Pages:             &d \n" ,adcPar.t4.Pages);
         printf("IrqStep:           %d \n" ,adcPar.t4.IrqStep);
         printf("FIFO:              %d \n" ,adcPar.t4.FIFO);
         printf("Rate:              %f \n" ,adcPar.t4.dRate);

         SetParametersStream(&hIfc, &adcPar.t4, CASE_ADC_PAR_1, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

         printf("Buffer size(ponits): %d \n" ,tm);
         printf("Pages:             &d \n" ,adcPar.t4.Pages);
         printf("IrqStep:           %d \n" ,adcPar.t4.IrqStep);
         printf("FIFO:              %d \n" ,adcPar.t4.FIFO);
         printf("Rate:              %f \n" ,adcPar.t4.dRate);

         IrqStep = adcPar.t4.IrqStep;
         pages = adcPar.t4.Pages;

      }
   }

   printf("\n Press any key \n");
   _getch();


   printf("Started ... \n");
//  
   fsize=multi*(pages/2)*IrqStep; //  

   hFile=CreateFile("data.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                               NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);

   if(hFile==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   hMap=CreateFileMapping(hFile,NULL,PAGE_READWRITE,0,fsize*2,NULL);

   if(hMap==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   fdata=(WORD *)MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,0);

   complete=0;

   EnableCorrection(&hIfc, 1);


//    
   InitStartLDevice(&hIfc);


//      
   hThread=CreateThread(0,0x2000,ServiceThread,0,0,&Tid);

   //    
   status = StartLDevice(&hIfc);


   while(!_kbhit())
   {
      ULONG syncd;
      GetSyncData(&hIfc, (ULONG)sync, 0, &syncd);
      printf(" %d \n", syncd);
      if(WAIT_OBJECT_0 == WaitForSingleObject(hThread,0)) { complete = 1; break; }
      Sleep(20);
   }

   if(!complete)
   {
      printf("Wait for thread completition... \n");
      InterlockedBitTestAndSet(&complete,0);
      WaitForSingleObject(hThread,INFINITE);
   }

   printf("StartLDevice returned  %s \n", (status ? "L_ERROR":"L_SUCCESS"));

   StopLDevice(&hIfc); //  


end:

   CloseLDevice(&hIfc);


   if(hThread) CloseHandle(hThread);

   if(fdata) UnmapViewOfFile(fdata);
   if(hMap) CloseHandle(hMap);
   if(hFile) CloseHandle(hFile);

   FreeAPIDLL(&hDll);
   printf("Exit \n");
   return 0;
}
