#! /bin/bash


#############################################
# Prerequisites:
# sudo apt install libatomic-ops-dev;
# sudo apt install wx-common libwxgtk3.0-dev;
#############################################

function build_lcard(){
 if [ -d "$1" ]; then
  echo -ne "\n\nStart build_lcard.\n\n";
  if pushd "$1"; then
   local target="$(realpath $PWD/../debug)";
   mkdir -pv $target; rm -fv $target/*;
   for dir in */; do
    if [ -f "$dir/Makefile" ]; then
     echo -ne "\n\nBuild in forder $dir";
     make -C "$dir";
    fi;
   done;
   make;
   make modules;
   for f in $(find . -type f -name '*.o');  do mv -fv $f $target/; done;
   for f in $(find . -type f -name '*.so'); do mv -fv $f $target/; done;
   for f in $(find . -type f -name '*.ko'); do mv -fv $f $target/; done;
   for f in dumpflash/dumpflash test/test;  do mv -fv $f $target/; done;
 fi;
  popd;
  echo -ne "\n\nDone build_lcard.\n\n";
 fi;
};

build_lcard $PWD/dstr;

