#ifndef USB_HARD_H_
#define USB_HARD_H_

extern const uint USB_IN_Array_Size;
extern const uint USB_OUT_Array_Size;
extern int USB_IN_ArrayCounter;
extern int USB_OUT_ArrayCounter;

void ContactUSB(bool Contacting);

__arm __ramfunc  void reg2mem
    (unsigned char* mem, AT91_REG* reg, unsigned int count);
__arm __ramfunc  void mem2reg
    (AT91_REG* reg, const unsigned char* mem, unsigned int count);


bool ReadUSB_FIFO_OUT(byte * pData, int length);
bool WriteUSB_FIFO_IN(byte * Data, int length);

bool WriteUSB_FIFO_OUT(byte * Data, int length);

__arm __ramfunc void USBWriteBulkInterrupt(void);
__arm __ramfunc void USBReadBulkInterrupt(void);

void ResetUSB(void);
void FlushFIFOBuffers(void);
void ResetUSBSoftly(void);

void ResetBulkEndpoint(unsigned int EndpointNumber);

bool WriteUSB(byte * pData, int length);
bool WriteUSB_FIFO(byte * pData, int length);
bool ReadUSB(byte * pData, int length);

#endif /* USB_HARD_H_ */
