#ifndef USB_HARDWARE_H_
#define USB_HARDWARE_H_

#include "USB_GlobDefsAsm.h"

#include "HAL.h"
#include "USBInterrupt.h"
#include "USBStack.h"
#include "USBStackDescriptor.h"
#include "USBHard.h"
#include "USBCmd.h"
#include "USBBackground.h"

/***************************************************************************
Interrupt_asm
****************************************************************************/
extern __arm __ramfunc void USB_Interrupt_Handler_asm(void);

/****************************************************************************
USB_Hard_asm
*****************************************************************************/
extern int
        USB_IN_ArrayPointer_Begin_Data, // ,   
        USB_IN_ArrayPointer_End_Data,
        USB_IN_ArrayCounter,
        USB_OUT_ArrayPointer_Begin_Data,
        USB_OUT_ArrayPointer_End_Data,
        USB_OUT_ArrayCounter;
extern __arm __ramfunc void Read_FIFO_IN_To_USB_FIFO_asm(int length);
extern __arm __ramfunc void Write_FIFO_OUT_To_USB_FIFO_asm(int length);

#endif /* USB_HARDWARE_H_ */
