#ifndef USB_HARDWARE_H_
#define USB_HARDWARE_H_

#include "USB_GlobDefs.h"

#include "HAL.h"
#include "USBInterrupt.h"
#include "USBStack.h"
#include "USBStackDescriptor.h"
#include "USBHard.h"
#include "USBCmd.h"
#include "debug.h"

/*================================================================================================*/
#if 1
#define __USB_BEGIN_CRITICAL()  DisableInterruptsMask(1 << AT91C_ID_UDP)
#define __USB_END_CRITICAL()    EnableInterruptsMask(1 << AT91C_ID_UDP)
#else
#define __USB_BEGIN_CRITICAL()  __disable_interrupt()
#define __USB_END_CRITICAL()    __enable_interrupt()
#endif

#if DEBUG_LED_IRQ_DISABLED
#define USB_BEGIN_CRITICAL(n)   do { if (n) DEBUG_LED_ON(); __USB_BEGIN_CRITICAL(); } while(0)
#define USB_END_CRITICAL(n)     do { __USB_END_CRITICAL(); if (n) DEBUG_LED_OFF(); } while(0)
#else
#define USB_BEGIN_CRITICAL(n)   __USB_BEGIN_CRITICAL()
#define USB_END_CRITICAL(n)     __USB_END_CRITICAL()
#endif
/*================================================================================================*/

/***************************************************************************
Interrupt handler
****************************************************************************/
__arm __ramfunc void USB_Interrupt_Handler(void);

#endif /* USB_HARDWARE_H_ */
