/*================================================================================================*
 *      Flash  
 *================================================================================================*/

#ifndef FLASH_H_
#define FLASH_H_

/*================================================================================================*/
#define FLASH_FIRMWARE_START    0x00104000  /*    */
#define FLASH_MAX_FW_SIZE       (0x00140000 - FLASH_FIRMWARE_START) /* SAM7S256: 256K Flash */
#define FLASH_PAGE_SIZE         256         /*   FLASH   */

/*    */
#define FLASH_FWMODE_FASTRUN    0x00000001  /* 1 =  , 0 =  USB  */
/*================================================================================================*/

/*================================================================================================*/
/*    */
typedef struct
    {
    unsigned long FirmwareVersion;  /*  : major << 8 + minor */
    unsigned long FirmwareDateBCD;  /*  BCD (0xYYYYMMDD) */
    unsigned long FirmwareSize;     /*     */
    unsigned long FirmwareCRC32;    /* CRC32  */
    unsigned long FirmwareMode;     /*    ( FLASH_FWMODE_...) */
    }
    t_FLASH_Metadata;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
int FLASH_CheckFirmwareState        /*       */
    (
    const t_FLASH_Metadata **pMeta  /* () -     */
    );                              /*  1,   ,  0 */
/*------------------------------------------------------------------------------------------------*/
int FLASH_WriteFirmwareBlock        /*     */
    (
    unsigned long FirmwareOffset,   /* ()  -   ,  FLASH_PAGE_SIZE */
    const unsigned long *pData,     /* ()  -    ( 4!) */
    unsigned int BlockSize          /* ()  -    ,  FLASH_PAGE_SIZE */
    );                              /*  1  , 0 =   */
/*------------------------------------------------------------------------------------------------*/
int FLASH_WriteMetadata             /*    */
    (
    const t_FLASH_Metadata *pMeta   /* ()  -   */
    );                              /*  1  , 0 =   */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* FLASH_H_ */
