/*================================================================================================*
 *   -
 *================================================================================================*/

#ifndef PIO_H_
#define PIO_H_

#include "chipio.h"

/*================================================================================================*/
#define PIO_USE_PWM         0       /* 1 =  PWM   (   ) */

#define PIO_USB_PULLUP      AT91C_PIO_PA0
#define PIO_LED             AT91C_PIO_PA3                       /* out, active high */
#define PIO_ALTBOOT         AT91C_PIO_PA21                      /* in, active high */
#define PIO_NPCS3           AT91C_PIO_PA22                      /* out, =1 at start */
#define PIO_LOW_POWER       AT91C_PIO_PA31                      /* out, active high */
#define PIO_N_RESET         AT91C_PIO_PA25                      /* in/out, open drain, active low */

#if PIO_USE_PWM
#define PIO_PWM             (AT91C_PIO_PA23 | AT91C_PIO_PA24)   /* out, =(1,1) at start */
#endif
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void PIO_Init                       /*   (  PA0) */
    (void);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* PIO_H_ */
