/*================================================================================================*
 *   
 *================================================================================================*/

#include "clk.h"

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void CLK_InitClocks                 /*    */
    (void)
    {
    /*    */
    /* OSCOUNT = CLK_STARTUP_MCS * CLK_SLOW_FREQ / 8 / 1000000 */
    AT91C_BASE_PMC->PMC_MOR =
        AT91C_CKGR_MOSCEN |
        (AT91C_CKGR_OSCOUNT & ((CLK_STARTUP_MCS * CLK_SLOW_FREQ / 8000000) << 8));
    /*   */
    while (!(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MOSCS));

    /*  PLL */
    AT91C_BASE_PMC->PMC_PLLR =
        (AT91C_CKGR_DIV & CLK_PLL_DIV) |
        (AT91C_CKGR_PLLCOUNT & (0x3F << 8)) |
        AT91C_CKGR_OUT_0 |
        (AT91C_CKGR_MUL & ((CLK_PLL_MUL - 1) << 16)) |
        (AT91C_CKGR_USBDIV & (CLK_USB_DIV_LOG2 << 28));
    /*   PLL */
    while (!(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_LOCK));

    /*   MCK */
    while (!(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY));

    /*     flash */
    AT91C_BASE_MC->MC_FMR =
#if CLK_MCK_FREQ > 30000000
        AT91C_MC_FWS_1FWS |
#else
        AT91C_MC_FWS_0FWS |
#endif
        /* FMCN =    1.5  */
        AT91C_MC_FMCN & (((CLK_MCK_FREQ * 3 + 2000000 - 1) / 2000000) << 16);

    /*   MCK    */
    AT91C_BASE_PMC->PMC_MCKR = (AT91C_BASE_PMC->PMC_MCKR & ~AT91C_PMC_PRES) |
        (AT91C_PMC_PRES & (CLK_MCK_DIV_LOG2 << 2));
    while (!(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY));
    AT91C_BASE_PMC->PMC_MCKR = (AT91C_BASE_PMC->PMC_MCKR & ~AT91C_PMC_CSS) |
        AT91C_PMC_CSS_PLL_CLK;
    while (!(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY));

    /*   USB   */
    AT91C_BASE_PMC->PMC_SCER = AT91C_PMC_PCK | AT91C_PMC_UDP;
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
