/*================================================================================================*
 *      USB (control channel)
 *================================================================================================*/

#ifndef USB_BACKGROUND_H_
#define USB_BACKGROUND_H_

/*================================================================================================*/
#define USBBG_DEFBUF_SIZE   1024    /*    control pipe   */
#define USBBG_READ          0       /*  :      */
#define USBBG_WRITE         1       /*  :      */
/*================================================================================================*/

/*================================================================================================*/
typedef int (*t_USBBG_Callback)     /* Callback- */
    (
    unsigned int UserParam,         /*   -  */
    unsigned char *pBuffer,         /*  (  - ,   - ) */
    unsigned int RequestLen         /* ,    */
    );                              /*     -1   */
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
int USBBG_Begin                     /*          */
    (
    int Direction,                  /* ()  - USBBG_READ  USBBG_WRITE */
    unsigned int UserParam,         /* ()  -   -  */
    unsigned int USBRequestSize,    /* ()  -   */
    t_USBBG_Callback Callback       /* ()  -   callback   */
    );                              /*  1    0   */
/*------------------------------------------------------------------------------------------------*/
int USBBG_BeginWithBuffer           /*         */
    (
    int Direction,                  /* ()  - USBBG_READ  USBBG_WRITE */
    unsigned int UserParam,         /* ()  -   -  */
    unsigned int USBRequestSize,    /* ()  -   */
    t_USBBG_Callback Callback,      /* ()  -   callback   */
    void *pBuffer,                  /* ()  -    */
    unsigned int BufferSize         /* ()  -   (    USBRequestSize) */
    );                              /*  1    0   */
/*------------------------------------------------------------------------------------------------*/
int USBBG_RequestError              /*    ( stall) */
    (void);                         /*  1    0   */
/*------------------------------------------------------------------------------------------------*/
int USBBG_RequestOK                 /*    (  ) */
    (void);                         /*  1    0   */
/*------------------------------------------------------------------------------------------------*/
int USBBG_TaskRunning               /* ,       */
    (void);
/*------------------------------------------------------------------------------------------------*/
void USBBG_Worker                   /*      main() */
    (void);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* USB_BACKGROUND_H_ */
