#ifndef USB_HARD_H_
#define USB_HARD_H_

#define ReadyReadBytes USB_OUT_ArrayCounter
#define BytesInWriteFIFO USB_IN_ArrayCounter

extern int
        USB_IN_ArrayPointer_Begin_Data, // ,   
        USB_IN_ArrayPointer_End_Data,
        USB_IN_ArrayCounter,
        USB_OUT_ArrayPointer_Begin_Data,
        USB_OUT_ArrayPointer_End_Data,
        USB_OUT_ArrayCounter;

extern const uint USB_IN_Array_Size;
extern const uint USB_OUT_Array_Size;

extern DWORD USB_FIFO_ArrayDWORD[];

void ContactUSB(bool Contacting);

bool ReadUSB_FIFO_OUT(byte * pData, int length);
bool WriteUSB_FIFO_IN(byte * Data, int length);

bool WriteUSB_FIFO_OUT(byte * Data, int length);

__arm __ramfunc void USBWriteBulkInterrupt(void);
__arm __ramfunc void USBReadBulkInterrupt(void);

void ResetUSB(void);
void FlushFIFOBuffers(void);
void ResetUSBSoftly(void);

void ResetBulkEndpoint(unsigned int EndpointNumber);

void InitializeTransferUSBSoft(void);

bool WriteUSB(byte * pData, int length);
bool WriteUSB_FIFO(byte * pData, int length);
bool ReadUSB(byte * pData, int length);

#endif /* USB_HARD_H_ */
