/*================================================================================================*
 *       
 *================================================================================================*/

#ifndef BOOTROM_H_
#define BOOTROM_H_

#include "USB.h"

/*================================================================================================*/
/*      bootrom'    */
#define BOOTCMD_NONE                0x00
#define BOOTCMD_ENTER_BOOTROM       0x01
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
int BOOTROM_Present                 /*    */
    (void);                         /*  0  1 */
/*------------------------------------------------------------------------------------------------*/
void BOOTROM_Clear                  /*        */
    (void);                         /*    USB    */
/*------------------------------------------------------------------------------------------------*/
unsigned char BOOTROM_GetCommand    /*      */
    (void);                         /*     BOOTROM_CMD_NONE */
/*------------------------------------------------------------------------------------------------*/
int BOOTROM_GetRequest              /*   USB     */
    (
    USBRequest *pRequest            /* () -    */
    );                              /*  1,    ,  0 */
/*------------------------------------------------------------------------------------------------*/
void BOOTROM_SetCommand             /*      */
    (
    unsigned char Command           /* ()  -  (BOOTROM_CMD_...) */
    );                              /*     */
/*------------------------------------------------------------------------------------------------*/
void BOOTROM_SetRequest             /*  USB     */
    (
    const USBRequest *pRequest      /* ()  -     */
    );                              /*      */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* BOOTROM_H_ */
