/*================================================================================================*
 *  ,   ,   .
 *================================================================================================*/

#ifndef BUFFERS_H_
#define BUFFERS_H_

#include "adc.h"
#include "dac.h"
#include "Configure_USB.h"

/*================================================================================================*/
/*     */
#pragma pack(push, 4)
typedef struct
    {
    union /*   */
        {
        /*     */
        volatile short int asRing [ADC_NBLOCKS] [ADC_BLK_SIZE_W];
        /*       */
        volatile short int asFrame [ADC_MAX_CH];
        }
        ADC;
    union /*   */
        /*   = 32 ,   16-  (    ) */
        {
        /*     */
        volatile unsigned int asRing [DAC_NBLOCKS] [DAC_BLK_SIZE_DW];
        /*     */
        /*    1   DMA      ,
           . dac.c */
        volatile unsigned int asFrame [DAC_BUFFER_SIZE_DW_TOTAL];
        }
        DAC;
    unsigned int USB_FIFO_OUT [(USB_FIFO_OUT_ARRAY_SIZE + 3) / 4];
    unsigned int USB_FIFO_IN [(USB_FIFO_IN_ARRAY_SIZE + 3) / 4];
    }
    t_GlobalBufRec;
#pragma pack(pop)

extern t_GlobalBufRec g_Buf;
/*================================================================================================*/
#endif /* BUFFERS_H_ */
