/*================================================================================================*
 *   
 *================================================================================================*/

#ifndef CLK_H_
#define CLK_H_

#include "chipio.h"

/*================================================================================================*/
#define CLK_QUARTZ_FREQ     12000000UL

#define CLK_PLL_MUL         8
#define CLK_PLL_DIV         1
#define CLK_PLL_FREQ        (CLK_QUARTZ_FREQ * CLK_PLL_MUL / CLK_PLL_DIV)

#define CLK_MCK_DIV_LOG2    1       /* n = 0..2, USB_clock = PLL_clock >> n */
#define CLK_USB_DIV_LOG2    1       /* n = 0..6, MCK_clock = PLL_clock >> n */

#define CLK_MCK_FREQ        (CLK_PLL_FREQ >> CLK_MCK_DIV_LOG2)

#define CLK_SLOW_FREQ       32000

#define CLK_STARTUP_MCS     1000  /*     ,  */

/*    USB  */
enum ClockDestination
    {
    PROCESSOR_CLOCK = 0,
    USB_PORT_CLOCK = 7,
    PROGRAMMABLE_CLOCK0 = 8,
    PROGRAMMABLE_CLOCK1 = 9,
    PROGRAMMABLE_CLOCK2 = 10
    };
#define SetDeviceClock(device, enable)  do {\
    if (enable) { AT91C_BASE_PMC->PMC_SCER = (1 << device); } \
           else { AT91C_BASE_PMC->PMC_SCDR = (1 << device); } \
    } while (0)
#define EnablePeripheralClock(Mask)   AT91C_BASE_PMC->PMC_PCER = Mask
#define DisablePeripheralClock(Mask)  AT91C_BASE_PMC->PMC_PCDR = Mask
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void CLK_InitClocks                 /*    */
    (void);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* CLK_H_ */
