/*================================================================================================*
 *  EEPROM
 *================================================================================================*/

#ifndef EEPROM_H_
#define EEPROM_H_

/*================================================================================================*/
#define EEPROM_8KBIT        1

/*    EEPROM */
#if EEPROM_8KBIT
#define EEPROM_SIZE         0x0400  /*   EEPROM   */
#define EEPROM_PAGE_SIZE    32      /*   EEPROM ( ) */
#else
#define EEPROM_SIZE         0x0080  /*   EEPROM   */
#define EEPROM_PAGE_SIZE    8       /*   EEPROM ( ) */
#endif

/*    EEPROM */
#define EEPROM_ST_BUSY      0x01    /*   (  ) */
#define EEPROM_ST_WREN      0x02    /*     (WREN) */
/*     */
#define EEPROM_WP_NONE      0x00    /*      */
#define EEPROM_WP_QUARTER   0x04    /* 1/4   -   */
#define EEPROM_WP_HALF      0x08    /* 1/2   -   */
#define EEPROM_WP_ALL       0x0C    /*      */
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
unsigned char EEPROM_GetChipState   /*    EEPROM */
    (void);                         /*     0xFF   */
/*------------------------------------------------------------------------------------------------*/
int EEPROM_Protect                  /*      EEPROM */
    (
    unsigned int NewState,          /* ()  -   (SPI_EEPROM_WP_...) */
    unsigned int ChipTimeout        /* ()  -    ,  (0 = ) */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
int EEPROM_Read                     /*    EEPROM */
    (
    unsigned int StartAddr,         /* ()  -    EEPROM */
    unsigned int NumBytes,          /* ()  -    */
    unsigned char *pBuffer          /* () - - */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
int EEPROM_Write                    /*    EEPROM */
    (
    unsigned int StartAddr,         /* ()  -    EEPROM */
    unsigned int NumBytes,          /* ()  -    */
    const unsigned char *pBuffer,   /* ()  - - */
    unsigned int ChipTimeout        /* ()  -    ,  (0 = ) */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* EEPROM_H_ */
