#ifndef MAIN_H_
#define MAIN_H_

#include "Configure_USB.h"

/*================================================================================================*/
/* 0 =  , 1 =  */
#define THIS_IS_BOOTROM     0
/*================================================================================================*/

/*================================================================================================*/
#define VER_MAJOR   3
#define VER_MINOR   10
/*================================================================================================*/

/*================================================================================================*/
/*        */
#define MAIN_RESET_DEVICE           0x8000
#define MAIN_JUMP_TO_BOOTROM        0x4000
#define MAIN_ENTER_SLEEP_MODE       0x2000
#define MAIN_EXIT_SLEEP_MODE        0x1000

/*        USB SUSPEND */
#define MAIN_SLEEP_ON_USB_SUSPEND   0

/*     ( ) */
#define MAIN_ENABLE_PRNG			0

/*   */
#define MODULE_NAME  "E140\0\0"
/*================================================================================================*/

/*================================================================================================*/
typedef struct
    {
    unsigned char VerMinor, VerMajor;
    unsigned char Date[14];
    }
    t_VersionInfo;

/*   (  GetArray GETA_DIAG_VARS) */
#define DIAG_DEVSTATE_ADC_STARTED   0x00000001
#define DIAG_DEVSTATE_DAC_STARTED   0x00000002
#pragma pack(4)
typedef struct
    {
    unsigned int DeviceState;
    unsigned int ADC_OverrunCount;
    unsigned int DAC_UnderrunCount;
    unsigned int ADC_SampleCount;
    unsigned int DAC_SampleCount;
    }
    t_DiagVars;
#pragma pack()

/*    ,     */
#define INC_SATURATE(var)       do { if ((var) + 1) (var)++; } while (0)
/*   /   */
#define DIAG_SET_FLAG(mask)     do { g_Diag.DeviceState |= (mask); } while (0)
#define DIAG_CLEAR_FLAG(mask)   do { g_Diag.DeviceState &= ~(mask); } while (0)
/*================================================================================================*/

/*================================================================================================*/
extern unsigned int g_MainFlag;
extern const char ModuleName[7];
extern const t_VersionInfo VersionInfo;
extern t_DiagVars g_Diag;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
int SetLowPowerMode                 /*     */
    (
    int LowPower                    /* ()  -   (1)   (0)  */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif /* MAIN_H_ */
