/*================================================================================================*
 *    ( )
 *================================================================================================*/

#ifndef NVRAM_H_
#define NVRAM_H_

/*================================================================================================*/
#define NVRAM_DEVDESC_SIZE      0x80    /*      */
#define NVRAM_USERAREA_SIZE     0x200   /*    NVRAM   */

/*      Flash,     
    NVRAM_FlushBuffers() */
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void NVRAM_Init                     /*  */
    (void);
/*------------------------------------------------------------------------------------------------*/
void NVRAM_FlushBuffers             /*   ,  ,  NVRAM */
    (void);
/*------------------------------------------------------------------------------------------------*/
int NVRAM_ReadDeviceDescriptor      /*    */
    (
    unsigned int ByteOffset,        /* ()  -     */
    unsigned char *pBuffer,         /* () -     */
    unsigned int NumBytes           /* ()  -    */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
int NVRAM_WriteDeviceDescriptor     /*    */
    (
    unsigned int ByteOffset,        /* ()  -     */
    const unsigned char *pBuffer,   /* ()  -   */
    unsigned int NumBytes           /* ()  -    */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
int NVRAM_ReadUserArea              /*    NVRAM */
    (
    unsigned int ByteOffset,        /* ()  -     */
    unsigned char *pBuffer,         /* () -     */
    unsigned int NumBytes           /* ()  -    */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
int NVRAM_WriteUserArea             /*     NVRAM */
    (
    unsigned int ByteOffset,        /* ()  -     */
    const unsigned char *pBuffer,   /* ()  -   */
    unsigned int NumBytes           /* ()  -    */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
void NVRAM_WriteEnable              /*    */
    (
    int Enable                      /* ()  - 1 =   , 0 =   */
    );
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* NVRAM_H_ */
