/*================================================================================================*
 *  SPI (, slave  EEPROM, master)
 *================================================================================================*/

#ifndef SPI_H_
#define SPI_H_

/*================================================================================================*/
/*  SPI */
#define SPI_MODE_CLOSED     0
#define SPI_MODE_MASTER     1
#define SPI_MODE_SLAVE      2

/*   NPCS    */
#define SPI_CONT            0       /*   NPCS   */
#define SPI_LAST            1       /*  NPCS   */
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void SPI_Init                       /*   SPI */
    (void);
/*------------------------------------------------------------------------------------------------*/
void SPI_Close                      /*  SPI      Z */
    (void);
/*------------------------------------------------------------------------------------------------*/
int SPI_OpenForDAC                  /*  SPI   (  slave) */
    (void);                         /*  1    0,  SPI   */
/*------------------------------------------------------------------------------------------------*/
int SPI_OpenForEEPROM               /*  SPI    EEPROM */
    (void);                         /*  1    0,  SPI   */
    /* : ,       SPI- */
/*------------------------------------------------------------------------------------------------*/
int SPI_IsOpenAs                    /*    SPI */
    (
    int Mode                        /* ()  -    (SPI_MODE_...) */
    );                              /*  1,     */
/*------------------------------------------------------------------------------------------------*/
void SPI_StartDMATransmit           /*    DMA ( ) */
    (                               /*  DMA     */
    int EnableDMAInterrupt
    );
/*------------------------------------------------------------------------------------------------*/
unsigned int SPI_Xfer               /*  -  SPI   master */
    (
    unsigned int TransmitData,      /* ()  -  ( 16 )   */
    int Last                        /* ()  -   ,  NPCS   */
    );                              /*    (RD) */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* SPI_H_ */
