/*================================================================================================*
 *  
 * 1.   (PIT) -   (  )
 * 2. -   (TCLK0 -> TIOA2)
 *================================================================================================*/

#ifndef TIMERS_H_
#define TIMERS_H_

#include "clk.h"
#include "wdt.h"

/*================================================================================================*/
#define TC1_CLK_SELECT      AT91C_TC_CLKS_TIMER_DIV5_CLOCK /* MCK/1024 */
#define TC1_CLK_PER_MS      ((CLK_MCK_FREQ + 512000) / 1024000)
#if TC1_CLK_PER_MS < 1
#error "TC1 clock invalid, check MCK"
#endif
/*================================================================================================*/

/*================================================================================================*/
extern int g_TIMER_BlinkFlag;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void TIMER_Init                     /*     PIT */
    (void);
/*------------------------------------------------------------------------------------------------*/
inline void TIMER_StartTimeout      /*   */
    (
    unsigned int msec               /*    ( 65535 / TC1_CLK_PER_MS) */
    )
    {
    AT91C_BASE_TC1->TC_RC = (msec < 0xFFFF / TC1_CLK_PER_MS) ? (msec * TC1_CLK_PER_MS) : 0xFFFF;
    AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN | AT91C_TC_SWTRG;
    }
/*------------------------------------------------------------------------------------------------*/
inline int TIMER_TimeoutExpired     /*  ,  TIMER_StartTimeout() */
    (void)                          /*  1,        */
    {
    return ((AT91C_BASE_TC1->TC_SR & AT91C_TC_CLKSTA) == 0);
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* TIMERS_H_ */
