#include "USB_USBMain.h"

void InitializeUSB(void)
{
  /* When using the USB debugger the peripheral registers do not always get
  set to the correct default values.  To make sure set the relevant registers
  manually here. */

  SetDeviceClock(USB_PORT_CLOCK, true); //  USB
  EnablePeripheralClock(1<<AT91C_ID_UDP);
  /* Enable the transceiver. */
  AT91C_BASE_UDP->UDP_TXVC = 0;

  Disable_USB_Interrupts(DISABLE_ALL_IT); //   
  Clear_Usb_Interrupts(CLEAR_ALL_IT); //   

  AT91C_BASE_UDP->UDP_CSR[0] = 0;
  AT91C_BASE_UDP->UDP_CSR[1] = 0;
  AT91C_BASE_UDP->UDP_CSR[2] = 0;
  AT91C_BASE_UDP->UDP_CSR[3] = 0;
  AT91C_BASE_UDP->UDP_GLBSTATE = 0;
  AT91C_BASE_UDP->UDP_FADDR = 0;
}

void DisconnectUSB(void)
    {
    register unsigned int k;
    AT91C_BASE_UDP->UDP_TXVC = 1;
    DisablePeripheralClock(1<<AT91C_ID_UDP);
    DisableInterruptsMask(1<<AT91C_ID_UDP);
    ContactUSB(false);
    /*    10 ,  USB  ,    */
    /* 6   , ~11  (CLK_MCK_FREQ/90) */
    k = CLK_MCK_FREQ / 90 / 6;
    while (k--)
        {__asm("nop");}
    }

void ConnectUSB(void)
{
  __disable_interrupt();

  DisconnectUSB();

  InitializeUSB();

  SetInterrupt(AT91C_ID_UDP,( void (*)(void) )USB_Interrupt_Handler_asm, PRI_ABOVE_NORMAL, INTERNAL_HIGH_LEVEL);

  Disable_USB_Interrupts(DISABLE_ALL_IT);
  Clear_Usb_Interrupts(CLEAR_ALL_IT);

  ContactUSB(true);

  EnableInterruptsMask(1<<AT91C_ID_UDP);
  __enable_interrupt();
}

void ConnectUSBFromBoot(void)
{
  __disable_interrupt();

//  DisconnectUSB();

//  InitializeUSB();

  SetInterrupt(AT91C_ID_UDP,( void (*)(void) )USB_Interrupt_Handler_asm, PRI_ABOVE_NORMAL, INTERNAL_HIGH_LEVEL); //      USB -  -      ,           !!!

 // Disable_USB_Interrupts(DISABLE_ALL_IT);
 // Clear_Usb_Interrupts(CLEAR_ALL_IT);

//  ContactUSB(true);

    EnableInterruptsMask(1<<AT91C_ID_UDP);
    __enable_interrupt();
}
